/*
 *  TOPPERS/DeviceManager
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      DeviceManager
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2006-2009 by Embedded and Real-Time Systems Laboratory
 *            Graduate School of Information Science, Nagoya Univ., JAPAN  
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 *
 *  @(#) $Id: stdafx.cpp,v 1.11 2003/12/24 07:40:42 takayuki Exp $
 */

/*
 * foCX}l[W {(CExeModule)
 */

#pragma warning(disable:4786)	//fobO255ɐ؂l߂܂
#pragma warning(disable:4200)	//W̊g@\gĂ܂ (s̔z:465s)

#include "stdafx.h"

#ifdef _ATL_STATIC_REGISTRY
#include <statreg.h>
#include <statreg.cpp>
#endif

#include <atlimpl.cpp>
#include <algorithm>

#include <initguid.h>
#include <CString>
#include "devicemanager.h"
#include "device.h"
#include "kernel.h"
#include "information.h"
#include "kernellog.h"

using namespace std;

#ifdef _DEBUG
	DWORD Count;
	char Buffer[1024];
	#define DebugOut(x) ::WriteFile(::GetStdHandle(STD_OUTPUT_HANDLE),Buffer, (x), &Count, NULL)
#else
	#define DebugOut(x) /##/
#endif

/*
 * \brief Xg}bvɍvfscopeɑ
 * \param[out] scope Xg}bṽCe[^
 * \param[in]  first T͈͂̏l
 * \param[in]  end   T͈͂̏Il
 * \param[in]  exp   T
 * ̃}N֐ĂяoƁAɍvfscopeɑD
 * ɍvfȂꍇendD
 */
#define FindIterator(scope, first, end, exp) \
	scope = first;\
	while(scope != end){\
		if(exp) break;\
		scope++;\
	}

/*
 * \brief CExeModulẽRXgN^
 * CExeModule쐬ɃNeBJZNV
 */
CExeModule::CExeModule(void)
{
	::InitializeCriticalSection(&cs);
}


/*
 * \brief n[hEFAV~[^ڑ
 * \param[in] device ڑCDeviceIuWFNgւ̃|C^
 * \retval    device CDeviceIuWFNgID
 * \retval    0      łɐڑĂꍇ
 * n[hEFAV~[^ڑꂽƂr[AɒʒmCCDevice
 * IuWFNgDeviceListɒǉD
 */
DeviceID CExeModule::AddDevice(CDevice *device)
{
	list<CDevice *>::iterator scope;
	list<CInformation *>::iterator view;

	::EnterCriticalSection(&cs);

	/* łDeviceListɓo^Ă邩mF */
	scope = find(DeviceList.begin(), DeviceList.end(), device);
	if(scope != DeviceList.end())
	{
		::LeaveCriticalSection(&cs);
		return 0;
	}

	/* SẴr[Aɒʒm */
	DebugOut(::wsprintfA(Buffer,"AddDevice\n"));
	view = ViewerList.begin();
	while(view != ViewerList.end())
	{
		(*view)->Fire_OnDeviceChanged(1,reinterpret_cast<long>(device));
		view ++;
	}

	/* DeviceListɒǉ */
	DeviceList.push_back(device);

	::LeaveCriticalSection(&cs);
	return reinterpret_cast<DeviceID>(device);
}

/*
 * \brief n[hEFAV~[^ؒf
 * \param[in] device ؒfCDeviceIuWFNg̃|C^
 * \retval    true   ؒfɐ
 * \retval    false  ؒfɎs
 */
bool CExeModule::DeleteDevice(CDevice *device)
{
	list<CDevice *>::iterator dev;
	map<Range,DevMem *>::iterator addressMap; /* AhX}bv */
	map<Range,DevMem *>::iterator tmp;
	list<SharedMem *>::iterator smem;

	::EnterCriticalSection(&cs);

	DebugOut(::wsprintfA(Buffer,"DelDevice\n"));

	
	dev = find(DeviceList.begin(), DeviceList.end(), device);
	/* Xgɓo^ĂȂꍇ*/
	if(dev == DeviceList.end())
	{
		::LeaveCriticalSection(&cs);
		return false;
	}

	/* AhX}bv̍폜 */
	addressMap = AddressMap.begin();
	while(addressMap!= AddressMap.end())
	{
		if(addressMap->second->device == device)
		{
			tmp = addressMap;
			addressMap ++;

			AddressMap.erase(tmp);
		}else
			addressMap ++;
	}

	DeviceList.erase(dev);

	/* r[A̍XV */
	list<CInformation *>::iterator view;
	view = ViewerList.begin();
	while(view != ViewerList.end())
	{
		(*view)->Fire_OnDeviceChanged(2,reinterpret_cast<long>(device));
		view ++;
	}

	/* Kv̂ȂȂL̍폜 */
	smem = SharedMemList.begin();
	addressMap = AddressMap.begin();
	while( smem != SharedMemList.end() )
	{
		if((*smem)->RmvDevRefList(device) == 0)
		{
			while( addressMap != AddressMap.end() )
			{
				if( addressMap->second->memory == (*smem) )
					break;
				addressMap ++;
			}
			if( addressMap == AddressMap.end() ) //NȂ͂
				FindIterator( addressMap, AddressMap.begin(), AddressMap.end(), addressMap->second->memory == (*smem) );
			if( addressMap != AddressMap.end() )
				AddressMap.erase(addressMap);
			SharedMemList.erase(smem);
			delete (*smem);
		}
		smem ++;
	}

	::LeaveCriticalSection(&cs);
	return true;
}

/*
 * \brief n[hEFAV~[^ɃAhX}bsO
 * \param[in] device }bsOCDeviceIuWFNg̃|C^
 * \param[in] area   }bsOAhẌ
 * \retval    true   }bsOɐ
 * \retval    false  }bsOɎs
 */
bool CExeModule::Map(CDevice *device, Range area)
{
	map<Range,DevMem *>::iterator scope;
	DevMem * devmem;

	::EnterCriticalSection(&cs);
	
	/* łɎgpĂȂmF */
	scope = AddressMap.begin();
	while(scope != AddressMap.end())
	{
		if( area.IsIncludedIn(scope->first) )
		{
			::LeaveCriticalSection(&cs);
			return false;
		}
		scope ++;
	}

	devmem = new DevMem(device);
	AddressMap[area] = devmem;

	DebugOut(::wsprintfA(Buffer,"Map\n"));
	list<CInformation *>::iterator view;
	view = ViewerList.begin();
	while(view != ViewerList.end())
	{
		(*view)->Fire_OnDeviceChanged(3,reinterpret_cast<long>(device),area.GetBase());
		view ++;
	}

	::LeaveCriticalSection(&cs);
	return true;
}


/*
 * \brief n[hEFAV~[^̃AhX}bsO
 * \param[in] device }bsOCDeviceIuWFNg̃|C^
 * \param[in] address}bsOAhẌɊ܂܂AhX
 * \retval    true   }bsOɐ
 * \retval    false  }bsOɎs
 */
bool CExeModule::Unmap(CDevice *device, unsigned long address)
{
	map<Range,DevMem *>::iterator scope;
	Range work(address);/* TCYP̃}bsOAhẌ@*/

	::EnterCriticalSection(&cs);

	/* n[hEFAV~[^̃AhX}bsO */
	scope = AddressMap.begin();
	while(scope != AddressMap.end())
	{
		if( scope->second->device == device && work.IsIncludedIn((*scope).first) )
		{
			AddressMap.erase(scope);

			DebugOut(::wsprintfA(Buffer,"Unmap\n"));
			list<CInformation *>::iterator view;
			view = ViewerList.begin();
			while(view != ViewerList.end())
			{
				(*view)->Fire_OnDeviceChanged(4,reinterpret_cast<long>(device),address);
				view ++;
			}

			::LeaveCriticalSection(&cs);

			return true;
		}
		scope ++;
	}
	::LeaveCriticalSection(&cs);

	return false;
}

/*
 * \brief r[Aڑ
 * \param[in] view ڑCInfomationIuWFNg̃|C^
 */
void CExeModule::AddViewer(CInformation *view)
{
	list<CInformation *>::iterator scope;

	::EnterCriticalSection(&cs);
	scope = find(ViewerList.begin(), ViewerList.end(), view);
	if(scope == ViewerList.end())
		ViewerList.push_back(view);
	::LeaveCriticalSection(&cs);
}

/*
 * \brief r[Aؒf
 * \param[in] view ؒfCInfomationIuWFNg̃|C^
 */
void CExeModule::RemoveViewer(CInformation *view)
{
	list<CInformation *>::iterator scope;

	::EnterCriticalSection(&cs);
	scope = find(ViewerList.begin(), ViewerList.end(), view);
	if(scope != ViewerList.end())
		ViewerList.erase(scope);
	::LeaveCriticalSection(&cs);
}

/*
 * \brief \tgEFAV~[^ڑ
 * \param[in] kernel ڑCKernelIuWFNg̃|C^
 * \retval    kernel CDeviceIuWFNgID
 * \retval    0      łɐڑĂꍇ
 */
KernelID CExeModule::AddKernel(CKernel *kernel)
{
	list<CKernel *>::iterator scope;
	list<CDevice *>::iterator device;
	list<CInformation *>::iterator view;
	list<CKernelLog *>::iterator watcher;

	::EnterCriticalSection(&cs);
	scope = find(KernelList.begin(), KernelList.end(), kernel);
	if(scope != KernelList.end())
	{
		return 0;
	}

	DebugOut(::wsprintfA(Buffer,"AddKernel\n"));

	/*
	if((Kernel != 0) && (Kernel != kernel))
	{
			//-1 => J[lKeepAlive
		if(FAILED(Kernel->Fire_OnInterruptRequest(-1)))
		{
				//ڑJ[l̃f^b`
			DetachKernel(Kernel);
		}else
		{
				//ڑς݃J[l
			if(::MessageBox(NULL,_T("VJ[lNAfoCX}l[Wɐڑ悤ƂĂ܂B\nVJ[lɐڑ؂ւ܂?"),_T("TOPPERS/JSP Windows - DeviceManager"),MB_YESNO) == IDYES)
				DetachKernel(Kernel);
		}
	}
	*/

	//if(Kernel == 0)
	/* n[hEFAV~[^ɒǉꂽƂʒm*/
	device = DeviceList.begin();
	while(device != DeviceList.end())
	{
		(*device)->Fire_OnKernelStart();
		device ++;
	}
	/* r[AɒǉꂽƂʒm*/
	view = ViewerList.begin();
	while(view != ViewerList.end())
	{
		(*view)->Fire_OnKernelChanged(1);
		view ++;
	}
	/* EHb`ɒǉꂽƂʒm*/
	watcher = WatcherList.begin();
	while(watcher != WatcherList.end())
	{
		(*watcher)->Fire_OnKernelStart();
		watcher ++;
	}
	DebugOut(::wsprintfA(Buffer,"AddKernel was performed successfully\n"));

	KernelList.push_back(kernel);
	::LeaveCriticalSection(&cs);

	return reinterpret_cast<KernelID>(kernel);
}

/*
 * \brief \tgEFAV~[^ؒf
 * \param[in] kernel ؒfCKernelIuWFNg̃|C^
 * \retval    true   ؒfɐ
 * \retval    false  ؒfɎs
 */
bool CExeModule::DeleteKernel(CKernel *kernel)
{
	//bool result;
	map<unsigned long,CKernel *>::iterator kernelMap;
	map<unsigned long,CKernel *>::iterator tmp;
	map<Range, DevMem *>::iterator scope;
	list<CKernel *>::iterator ker;
	list<CDevice *>::iterator dev;
	list<CInformation *>::iterator view;
	list<CKernelLog *>::iterator watcher;
	list<SharedMem *>::iterator smem;

	DebugOut(::wsprintfA(Buffer,"DetachKernel\n"));

	::EnterCriticalSection(&cs);

	ker = find(KernelList.begin(), KernelList.end(), kernel);
	/* Xgɓo^ĂȂꍇ*/
	if(ker == KernelList.end())
	{
		::LeaveCriticalSection(&cs);
		return false;
	}
    
	/* \tgEFAV~[^}bv폜 */
	kernelMap = KernelMap.begin();
	while(kernelMap != KernelMap.end())
	{
		if((*kernelMap).second == kernel)
		{
			tmp = kernelMap;
			kernelMap++;

			KernelMap.erase(tmp);
		}
		else
		{
			kernelMap ++;
		}

	}

	KernelList.erase(ker);
	/* Kv̂ȂȂL̍폜 */
	smem = SharedMemList.begin();
	scope = AddressMap.begin();
	while( smem != SharedMemList.end() )
	{
		if((*smem)->RmvKerRefList(kernel) == 0)
		{
			while( scope != AddressMap.end() )
			{
				if( scope->second->memory == (*smem) )
					break;
				scope ++;
			}
			if( scope == AddressMap.end() ) //NȂ͂
				FindIterator( scope, AddressMap.begin(), AddressMap.end(), scope->second->memory == (*smem) );
			if( scope != AddressMap.end() )
				AddressMap.erase(scope);
			SharedMemList.erase(smem);
			delete (*smem);
		}
		smem ++;
	}
	/* n[hEFAV~[^ɍ폜ꂽƂʒm*/
	dev = DeviceList.begin();
	while(dev != DeviceList.end())
	{
		(*dev)->Fire_OnKernelExit();
		dev ++;
	}
	/* r[Aɍ폜ꂽƂʒm*/
	view = ViewerList.begin();
	while(view != ViewerList.end())
	{
		(*view)->Fire_OnKernelChanged(2);
		view ++;
	}
	/* EHb`ɍ폜ꂽƂʒm*/
	watcher = WatcherList.begin();
	while(watcher != WatcherList.end())
	{
		(*watcher)->Fire_OnKernelExit();
		watcher ++;
	}

	DebugOut(::wsprintfA(Buffer,"DeleteKernel was performed successfully\n"));
	::LeaveCriticalSection(&cs);

	return true;
}
/*
 * \brief \tgEFAV~[^ɃvZbTID}bsO
 * \param[in] kernel }bsOCKernelIuWFNg̃|C^
 * \param[in] id     }bsOvZbTID
 * \retval    true   }bsOɐ
 * \retval    false  }bsOɎs
 */
bool CExeModule::MapKernel(CKernel * kernel, unsigned long id)
{
	map<unsigned long, CKernel *>::iterator scope;

	::EnterCriticalSection(&cs);

	/* łKernelMapɓo^Ă邩mF */
	scope = KernelMap.begin();
	while(scope != KernelMap.end())
	{
		if( (*scope).first == id )
		{
			::LeaveCriticalSection(&cs);
			return false;
		}
		scope ++;
	}

	KernelMap[id] = kernel;
	
	DebugOut(::wsprintfA(Buffer,"MapKernel\n"));

	::LeaveCriticalSection(&cs);
	return true;
}

/*
 * \brief \tgEFAV~[^̃vZbTID}bsO
 * \param[in] kernel }bsOCKernelIuWFNg̃|C^
 * \param[in] id     }bsOvZbTID
 * \retval    true   }bsOɐ
 * \retval    false  }bsOɎs
 */
bool CExeModule::UnmapKernel(CKernel * kernel, unsigned long id)
{
	map<unsigned long, CKernel *>::iterator scope;

	::EnterCriticalSection(&cs);

	scope = KernelMap.begin();
	/* Xgɓo^ĂȂꍇ */
	while(scope != KernelMap.end())
	{
		if( (*scope).second == kernel && (*scope).first == id )
		{
			KernelMap.erase(scope);

			DebugOut(::wsprintfA(Buffer,"UnmapKernel\n"));

			::LeaveCriticalSection(&cs);

			return true;
		}
		scope ++;
	}
	::LeaveCriticalSection(&cs);

	return false;
}

/*
 * \brief n[hEFAV~[^L̃f[^ǂݍ
 * \param[in]  kernel  voCKernelIuWFNg̃|C^
 * \param[in]  address ANZXΏۂ̊JnAhX
 * \param[in]  sz      ANZXΏۂ̃TCYioCgj
 * \param[out] data    f[^Ǎݗpobt@
 * \retval     true    Ǎ݂ɐ
 * \retval     false   Ǎ݂Ɏs
 */
bool CExeModule::Read(CKernel * kernel, unsigned long address, unsigned long sz, unsigned char data[])
{
	bool result;
	map<Range,DevMem *>::iterator devmap;
	list<CKernel *>::iterator scope;

	DebugOut(::wsprintfA(Buffer,"Read\n"));

	::EnterCriticalSection(&cs);

	scope = find(KernelList.begin(), KernelList.end(), kernel);
	/* Xgɓo^ĂȂꍇ */
	if(scope == KernelList.end())
	{
		::LeaveCriticalSection(&cs);
		DebugOut(::wsprintfA(Buffer,"Illegal Kernel\n"));
		return false;
	}

	devmap = AddressMap.find(Range(address,sz));
	
	result = (devmap != AddressMap.end());
	/* AhX}bvɃANZXΏۂ̗̈悪܂܂Ăꍇ */
	if(result){
		/* n[hEFAV~[^̏ꍇ */
		if(devmap->second->device != NULL){
			devmap->second->device->Fire_OnRead(address, sz, data);
		}
		/* L̏ꍇ */
		else{
			memcpy(data, devmap->second->memory->data + address - devmap->first.GetBase(), sz);
		}
	}

	::LeaveCriticalSection(&cs);

	return result;

}

/*
 * \brief n[hEFAV~[^L̃f[^
 * \param[in] kernel  voCKernelIuWFNg̃|C^
 * \param[in] address ANZXΏۂ̊JnAhX
 * \param[in] sz      ANZXΏۂ̃TCYioCgj
 * \param[in] data    f[^ݗpobt@
 * \retval    true    ݂ɐ
 * \retval    false   ݂Ɏs
 */
bool CExeModule::Write(CKernel *kernel, unsigned long address, unsigned long sz, unsigned char data[])
{
	bool result;
	map<Range,DevMem *>::iterator devmap;
	list<CKernel *>::iterator scope;

	DebugOut(::wsprintfA(Buffer,"Write\n"));

	::EnterCriticalSection(&cs);
	/* Xgɓo^ĂȂꍇ */
	scope = find(KernelList.begin(), KernelList.end(), kernel);
	if(scope == KernelList.end())
	{
		::LeaveCriticalSection(&cs);
		DebugOut(::wsprintfA(Buffer,"Request performed by Illegal Kernel\n"));
		return false;
	}

	devmap = AddressMap.find(Range(address,sz));
	
	result = (devmap != AddressMap.end());
	/* AhX}bvɃANZXΏۂ̗̈悪܂܂Ăꍇ */
	if(result)
	{
		DebugOut(::wsprintfA(Buffer,"FireWrite\n"));
		/* n[hEFAV~[^̏ꍇ */	
        if(devmap->second->device != NULL){
			devmap->second->device->Fire_OnWrite(address, sz,data);
		}
		/* L̏ꍇ@*/
		else{
			memcpy(devmap->second->memory->data + address - devmap->first.GetBase(), data, sz);
		}
	}
	::LeaveCriticalSection(&cs);

	return result;
}

/*
 * \brief \tgEFAV~[^Ɋ݂
 * \param[in] newinhno ݔԍi16rbgΏIDj
 * \retval    true     ݂ɐ
 * \retval    false    ݂Ɏs
 */
bool CExeModule::RaiseInterrupt(unsigned long newinhno)
{
	bool result = true;
	unsigned long id, inhno;
	list<CKernel *>::iterator kernel;
	map<unsigned long,CKernel *>::iterator scope;

	id = newinhno >> 16;
	inhno = newinhno & 0xffff;

	::EnterCriticalSection(&cs);
	/* SẴ\tgEFAV~[^ɏԂɊ݂ */
	if(id == 0x0000)
	{
		kernel = KernelList.begin();
		while(kernel != KernelList.end()){
			if((*kernel)->Fire_OnInterruptRequest(inhno) < 0)
				result = false;
			kernel++;
		}
	}
	/* idŎw肳ꂽvZbTɊ݂ */
	else{
		scope = KernelMap.find(id);
		if( scope != KernelMap.end() ){
			if( (*scope).second->Fire_OnInterruptRequest(inhno) < 0 )
				result = false;
		}
	}

	::LeaveCriticalSection(&cs);

	return result;
}

/*
 * \brief OEHb`ڑ
 * \param[in] watcher ڑCKernelLogIuWFNg̃|C^
 * \retval    true    ڑɐ
 * \retval    false   ڑɎs
 */
bool CExeModule::AddLogWatcher(CKernelLog * watcher)
{
	if( find(WatcherList.begin(), WatcherList.end(), watcher) != WatcherList.end() )
		return false;	//do^

	::EnterCriticalSection(&cs);
	WatcherList.push_back(watcher);
	::LeaveCriticalSection(&cs);

	DebugOut(::wsprintfA(Buffer,"Log watcher inserted into the queue successfully\n"));

	return true;
}


/*
 * \brief OEHb`ؒf
 * \param[in] watcher ؒfCKernelLogIuWFNg̃|C^
 * \retval    true    ؒfɐ
 * \retval    false   ؒfɎs
 */
void CExeModule::RemoveLogWatcher(CKernelLog * watcher)
{
	list<CKernelLog *>::iterator scope;

	::EnterCriticalSection(&cs);
	scope = find(WatcherList.begin(), WatcherList.end(), watcher);
	if(scope != WatcherList.end())
		WatcherList.erase(scope);
	::LeaveCriticalSection(&cs);

	DebugOut(::wsprintfA(Buffer,"Log watcher removed from the queue successfully\n"));
}



/*
 *  O̎ʂ̒`
 */
#define LOG_TYP_INTERRUPT	0x01	/* ݃nh */
#define LOG_TYP_ISR			0x02	/* ݃T[rXnh */
#define LOG_TYP_TIMERHDR	0x03	/* ^CCxgnh */
#define LOG_TYP_CPUEXC		0x04	/* CPUOnh */
#define LOG_TYP_TSKEXC		0x05	/* ^XNO[` */
#define LOG_TYP_TSKSTAT		0x06	/* ^XNԕω */
#define LOG_TYP_DISPATCH	0x07	/* fBXpb` */
#define LOG_TYP_SVC			0x08	/* T[rXR[ */
#define LOG_TYP_COMMENT		0x09	/* Rgî݂̃Oj */
#define LOG_ENTER			0x00	/* ^Jn */
#define LOG_LEAVE			0x80	/* o^I */


typedef	unsigned int BITMASK;

typedef struct {
		unsigned int	logtype;
		unsigned int	logtim;
		BITMASK			valid;
		unsigned int	bufsz;
		unsigned char	buf[];
	} DBIFLOG;
#define DBIFLOG_BUFMARGIN (sizeof(unsigned int)*4)

/*
 * \brief \tgEFAV~[^̃OOEHb`𑗐M
 * \param[in] kernel OMCKernelIuWFNg
 * \param[in] sz     ÕTCYioCgj
 * \param[in] data   Oe
 * \retval    true   OMɐ
 * \retval    false  OMɎs
 */
bool CExeModule::OnLogEvent(CKernel *kernel, long sz, unsigned char *data)
{
	list<CKernelLog *>::iterator watcher;
	list<CKernel *>::iterator scope;

#if 0

	DBIFLOG * log = reinterpret_cast<DBIFLOG *>(data);
	
	DebugOut(::wsprintfA(Buffer,"LOG <%08x> ",log->logtim));
	switch(log->logtype)
	{
	case LOG_TYP_TSKSTAT:
		DebugOut(::wsprintfA(Buffer,"[STATUS] Tsk:%d ",*(int*)log->buf));
		switch(*((int*)log->buf+1))
		{
		case 0x01:
		case 0x02:
			DebugOut(::wsprintfA(Buffer,"<Runnable [Ready+Running]>\n",*(int*)log->buf));
			break;
		case 0x04:
		case 0x0c:
			if(*((int*)log->buf+1) == 0x04)
				DebugOut(::wsprintfA(Buffer,"<Waiting : "));
			else
				DebugOut(::wsprintfA(Buffer,"<Wait-Suspend : "));

			switch(*((int*)log->buf+2))
			{
			case 0x1:
				DebugOut(::wsprintfA(Buffer,"Sleep>\n"));
				break;
			case 0x2:
				DebugOut(::wsprintfA(Buffer,"Delay>\n"));
				break;
			case 0x4:
				DebugOut(::wsprintfA(Buffer,"Semaphore>\n"));
				break;
			default:
				DebugOut(::wsprintfA(Buffer," complex [%04x]>\n", *((int*)log->buf+2)));
				break;
			}

			break;
		case 0x08:
			DebugOut(::wsprintfA(Buffer,"<Suspended>\n"));
			break;
		case 0x10:
			DebugOut(::wsprintfA(Buffer,"<Dormant>\n"));
			break;
		default:
			DebugOut(::wsprintfA(Buffer,"<Unknown : %d>",*(int*)log->buf));
			break;
		}
		break;

	case LOG_TYP_TSKEXC:
		DebugOut(::wsprintfA(Buffer,"[TSKEXC|ENT] Tsk:%d\n",*(int*)log->buf));
		break;

	case LOG_TYP_TSKEXC | LOG_LEAVE:
		DebugOut(::wsprintfA(Buffer,"[TSKEXC|LEA] Tsk:%d\n",*(int*)log->buf));
		break;

	case LOG_TYP_DISPATCH:
		if(*((int*)log->buf+1) == 0)
			DebugOut(::wsprintfA(Buffer,"[DSP|ENT] Tsk:%d Task-context\n",*(int*)log->buf));
		else
			DebugOut(::wsprintfA(Buffer,"[DSP|ENT] Tsk:%d Nontask-context\n",*(int*)log->buf));
		break;

	case LOG_TYP_DISPATCH | LOG_LEAVE:
		DebugOut(::wsprintfA(Buffer,"[DSP|LEA] Tsk:%d\n",*(int*)log->buf));		
		break;

	case LOG_TYP_COMMENT:
		DebugOut(::wsprintfA(Buffer,"[COMMENT (%d)] : ",log->bufsz));
		::WriteFile(::GetStdHandle(STD_OUTPUT_HANDLE), log->buf, log->bufsz-1, &Count, NULL);
		break;
	
	case LOG_TYP_INTERRUPT:
		DebugOut(::wsprintfA(Buffer,"[INT|ENT] %d\n",*(int*)log->buf));
		break;

	case LOG_TYP_INTERRUPT | LOG_LEAVE:
		DebugOut(::wsprintfA(Buffer,"[INT|LEA] %d\n",*(int*)log->buf));
		break;

	case LOG_TYP_CPUEXC:
		DebugOut(::wsprintfA(Buffer,"[CPUEXC|ENT] Tsk:%d\n",*(int*)log->buf));
		break;

	case LOG_TYP_CPUEXC | LOG_LEAVE:
		DebugOut(::wsprintfA(Buffer,"[CPUEXC|LEA] Tsk:%d\n",*(int*)log->buf));
		break;

	case LOG_TYP_TIMERHDR:
	case LOG_TYP_TIMERHDR | LOG_LEAVE:
		if((log->logtype & LOG_LEAVE) != 0)
			DebugOut(::wsprintfA(Buffer,"[INT|LEA]"));
		else
			DebugOut(::wsprintfA(Buffer,"[INT|ENT]"));

		if( *(int*)log->buf == 0x8d )
			DebugOut(::wsprintfA(Buffer," cyclic "));
		else
			DebugOut(::wsprintfA(Buffer," OBJ(%02x) ", *(int*)log->buf));

		DebugOut(::wsprintf(Buffer," ID:%d  EXINF:0x%08x\n",*((int*)log->buf+1), *((int*)log->buf+2)));
		break;

	default:
		DebugOut(::wsprintfA(Buffer,"[UNKNOWN:0x%x]\n",log->logtype));
	};
#endif
	
	/* kernelKernelListɓo^Ă邩mF */
	scope = find(KernelList.begin(), KernelList.end(), kernel);
	if(scope == KernelList.end())
	{
		DebugOut(::wsprintfA(Buffer,"Request performed by Illegal Kernel\n"));
		return false;
	}

	::EnterCriticalSection(&cs);
	/* ׂẴEHb`ɃO𑗐M */
	watcher = WatcherList.begin();
	while(watcher != WatcherList.end())
	{
		(*watcher)->Fire_OnLogEvent(sz, data);
		watcher ++;
	}
	::LeaveCriticalSection(&cs);

	return true;
}

/*
 * \brief Ow肵ċL쐬(\tgEFAV~[^̗v) 
 * \param[in] kernel  voCKernelIuWFNg
 * \param[in] address L̃AhX
 * \param[in] size    L̃TCYioCgj
 * \param[in] lpName  L̖O
 * \retval    true    L쐬ɐ
 * \retval    false   L쐬Ɏs
 */
bool CExeModule::CreateSharedMemory(CKernel * kernel, unsigned long address, unsigned long size, BSTR lpName)
{
	bool result = false;
	std::map<Range, DevMem *>::iterator scope;
	Range range(address, size);
	SharedMem * mem;
	DevMem * devmem;

	if(size == 0)
		return false;

	::EnterCriticalSection(&cs);

	FindIterator(scope, AddressMap.begin(), AddressMap.end(), range.IsIncludedIn(scope->first));
	/* L쐬łꍇ */
	if(scope == AddressMap.end())
	{
		mem = new SharedMem(address, size, lpName);
		if(mem->CreateMem(kernel))
		{
			devmem = new DevMem(mem);
			SharedMemList.push_back(mem);
			AddressMap[range] = devmem;
			result = true;
		}
		else
		{
			DebugOut(::wsprintfA(Buffer,"Request<CreateSharedMemory> failed memory allocation\n"));
			delete mem;
		}
	}
	/* łɃn[hEFAV~[^gpĂꍇ */
	else if(scope->second->device != NULL)
	{
		DebugOut(::wsprintfA(Buffer,"Request<CreateSharedMemory> failed\n"));
		DebugOut(::wsprintfA(Buffer,"request name : \"%s\", address : 0x%08x, size : 0x%08x\n", lpName, address, size));
		result = false;
	}
	/* łɋL쐬Ăꍇ */
	else if( scope->second->memory->bstr == lpName && range.IsEqual(scope->first) )
	{
		if( scope->second->memory->AddKerRefList(kernel) > 0 )
			result = true;
		else
			result = false;
	}
	/* łɍ쐬Ă鋤LƃAhXvɏdꍇ */
	else
	{
		DebugOut(::wsprintfA(Buffer,"Request<CreateSharedMemory> failed\n"));
		DebugOut(::wsprintfA(Buffer,"request name : \"%s\", address : 0x%08x, size : 0x%08x\n", lpName, address, size));
		result = false;
	}
	::LeaveCriticalSection(&cs);
	return result;
}

/*
 * \brief Ow肵ċL쐬in[hEFAV~[^̗vj
 * \param[in] device  voCDeviceIuWFNg
 * \param[in] address L̃AhX
 * \param[in] size    L̃TCYioCgj
 * \param[in] lpName  L̖O
 * \retval    true    L쐬ɐ
 * \retval    false   L쐬Ɏs
 */
bool CExeModule::CreateSharedMemory(CDevice * device, unsigned long address, unsigned long size, BSTR lpName)
{
	bool result = false;
	std::map<Range, DevMem *>::iterator scope;
	Range range(address, size);
	SharedMem * mem;
	DevMem * devmem;

	if(size == 0)
		return false;

	::EnterCriticalSection(&cs);
	/* L쐬łꍇ */
	FindIterator(scope, AddressMap.begin(), AddressMap.end(), range.IsIncludedIn(scope->first));
	if(scope == AddressMap.end())
	{
		mem = new SharedMem(address, size, lpName);
		if(mem->CreateMem(device))
		{
			devmem = new DevMem(mem);
			SharedMemList.push_back(mem);
			AddressMap[range] = devmem;
			result = true;
		}
		else
		{
			DebugOut(::wsprintfA(Buffer,"Request<CreateSharedMemory> failed memory allocation\n"));
			delete mem;
		}
	}
	/* łɃn[hEFAV~[^gpĂꍇ */
	else if(scope->second->device != NULL)
	{
		DebugOut(::wsprintfA(Buffer,"Request<CreateSharedMemory> failed\n"));
		DebugOut(::wsprintfA(Buffer,"request name : \"%s\", address : 0x%08x, size : 0x%08x\n", lpName, address, size));
		result = false;
	}
	/* łɋL쐬Ăꍇ */
	else if( scope->second->memory->bstr == lpName && range.IsEqual(scope->first) )
	{
		if( scope->second->memory->AddDevRefList(device) > 0 )
			result = true;
		else
			result = false;
	}
	/* łɍ쐬Ă鋤LƃAhXvɏdꍇ */
	else
	{
		DebugOut(::wsprintfA(Buffer,"Request<CreateSharedMemory> failed\n"));
		DebugOut(::wsprintfA(Buffer,"request name : \"%s\", address : 0x%08x, size : 0x%08x\n", lpName, address, size));
		result = false;
	}
	::LeaveCriticalSection(&cs);
	return result;
}

/*
 * \brief Li\tgEFAV~[^̗vj
 * \param[in] kernel  voCKernelIuWFNg
 * \param[in] lpName  L̖O
 * \retval    true    Lɐ
 * \retval    false   LɎs
 */
bool CExeModule::ReleaseSharedMemory(CKernel * kernel, BSTR lpName)
{
	std::map<Range, DevMem *>::iterator scope;
	std::list<class SharedMem *>::iterator smem;

	::EnterCriticalSection(&cs);
	FindIterator(smem, SharedMemList.begin(), SharedMemList.end(), (*smem)->bstr == lpName);
	if(smem != SharedMemList.end())
	{
		/* KvȂȂL̊J */ 
		if((*smem)->RmvKerRefList(kernel) == 0)
		{
			FindIterator(scope, AddressMap.begin(), AddressMap.end(),
				scope->second->memory == (*smem));
			if(scope == AddressMap.end()){
				DebugOut(::wsprintfA(Buffer,"Request<ReleaseSharedMemory> : The name couldn't be found in address map.\n"));
			}else{
				AddressMap.erase(scope);
			}
			SharedMemList.erase(smem);
			delete (*smem);
		}
		::LeaveCriticalSection(&cs);
		return true;
	}
	DebugOut(::wsprintfA(Buffer,"Request<ReleaseSharedMemory> not valid name\n"));
	::LeaveCriticalSection(&cs);
	return false;
}

/*
 * \brief Lin[hEFAV~[^̗vj
 * \param[in] device  voCDeviceIuWFNg
 * \param[in] lpName  L̖O
 * \retval    true    Lɐ
 * \retval    false   LɎs
 */
bool CExeModule::ReleaseSharedMemory(CDevice * device, BSTR lpName)
{
	std::map<Range, DevMem *>::iterator scope;
	std::list<class SharedMem *>::iterator smem;

	::EnterCriticalSection(&cs);
	FindIterator(smem, SharedMemList.begin(), SharedMemList.end(), (*smem)->bstr == lpName);
	if(smem != SharedMemList.end())
	{
		/* KvȂȂL̊J */ 
		if((*smem)->RmvDevRefList(device) == 0)
		{
			FindIterator(scope, AddressMap.begin(), AddressMap.end(),
				scope->second->memory == (*smem));
			if(scope == AddressMap.end()){
				DebugOut(::wsprintfA(Buffer,"Request<ReleaseSharedMemory> : The name couldn't be found in address map.\n"));
			}else{
				AddressMap.erase(scope);
			}
			SharedMemList.erase(smem);
			delete (*smem);
		}
		::LeaveCriticalSection(&cs);
		return true;
	}
	DebugOut(::wsprintfA(Buffer,"Request<ReleaseSharedMemory> not valid name\n"));
	::LeaveCriticalSection(&cs);
	return false;
}

/*
 * \brief OċL쐬AOԂ(\tgEFAV~[^̗v)
 * \param[in] kernel  voCKernelIuWFNg
 * \param[in] address L̃AhX
 * \param[in] size    L̃TCYioCgj
 * \retval    bstr    L̖O
 * \retval    NULL    L쐬Ɏsꍇ
 */
BSTR CExeModule::CreateSharedMemoryAnyName(CKernel * kernel, unsigned long address, unsigned long size)
{
	std::map<Range, DevMem *>::iterator scope;
	Range range(address, size);
	SharedMem * smem;
	DevMem * devmem;

	/* TCY`FbN */
	if(size == 0)
	{
		return NULL;
	}

	::EnterCriticalSection(&cs);

	FindIterator(scope, AddressMap.begin(), AddressMap.end(),
		range.IsIncludedIn(scope->first));
	/* L쐬łꍇ */
	if(scope == AddressMap.end())
	{
		smem = new SharedMem(address, size);
		if(smem->CreateMem(kernel))
		{
			SharedMemList.push_back(smem);
			devmem = new DevMem(smem);
			AddressMap[range] = devmem;
			::LeaveCriticalSection(&cs);
			return smem->bstr;
		}
		else
		{
			/* mۂɎsꍇ */
			DebugOut(::wsprintfA(Buffer,"Request<CreateSharedMemory2> failed memory allocation or naming\n"));
			delete smem;
		}
	}
	/* łɋL쐬Ăꍇ */
	else if(range.IsEqual(scope->first) && scope->second->memory != NULL)
	{
		smem = scope->second->memory;
		scope->second->memory->AddKerRefList(kernel);
		::LeaveCriticalSection(&cs);
		return smem->bstr;
	}
	/* ͈͂SɈvĂȂꍇ */
	else
	{
		DebugOut(::wsprintfA(Buffer,"Request<CreateSharedMemory2> conflicted in address and size\n"));
	}
	::LeaveCriticalSection(&cs);
	return NULL;
}

/*
 * \brief OċL쐬AOԂin[hEFAV~[^̗vj
 * \param[in] device  voCDeviceIuWFNg
 * \param[in] address L̃AhX
 * \param[in] size    L̃TCYioCgj
 * \retval    bstr    L̖O
 * \retval    NULL    L쐬Ɏsꍇ
 */
BSTR CExeModule::CreateSharedMemoryAnyName(CDevice * device, unsigned long address, unsigned long size)
{
	std::map<Range, DevMem *>::iterator scope;
	Range range(address, size);
	SharedMem * smem;
	DevMem * devmem;

	/* TCY`FbN */
	if(size == 0)
	{
		return NULL;
	}

	::EnterCriticalSection(&cs);
	FindIterator(scope, AddressMap.begin(), AddressMap.end(),
		range.IsIncludedIn(scope->first));
	/* L쐬łꍇ */
	if(scope == AddressMap.end())
	{
		smem = new SharedMem(address, size);
		if(smem->CreateMem(device))
		{
			SharedMemList.push_back(smem);
			devmem = new DevMem(smem);
			AddressMap[range] = devmem;
			::LeaveCriticalSection(&cs);
			return smem->bstr;
		}
		else
		{
			/* mۂɎsꍇ */
			DebugOut(::wsprintfA(Buffer,"Request<CreateSharedMemory2> failed memory allocation or naming\n"));
			delete smem;
		}
	}
	/* łɋL쐬Ăꍇ */
	else if(range.IsEqual(scope->first) && scope->second->memory != NULL)
	{
		smem = scope->second->memory;
		scope->second->memory->AddDevRefList(device);
		::LeaveCriticalSection(&cs);
		return smem->bstr;
	}
	/* ͈͂SɈvĂȂꍇ */
	else
	{
		DebugOut(::wsprintfA(Buffer,"Request<CreateSharedMemory2> conflicted in address and size\n"));
	}
	::LeaveCriticalSection(&cs);
	return NULL;
}

/*
 * \brief ~[ebNX쐬i\tgEFAV~[^̗vj
 * \param[in] id     ~[ebNXID
 * \param[in] ker    voCKernelIuWFNg
 * \retval    bstr   ~[ebNX̖O
 * \retval    NULL   ~[ebNX쐬Ɏsꍇ
 */
BSTR CExeModule::CreateMutex(unsigned long id, class CKernel *ker)
{
	std::list<class Mutex *>::iterator scope;
	class Mutex * mutex;

	::EnterCriticalSection(&cs);
	FindIterator( scope, MutexList.begin(), MutexList.end(),
		(*scope)->id == id );
	/* łɃ~[ebNX쐬Ăꍇ */
	if(scope != MutexList.end())
	{
		/* V~[^~[ebNX̎QƃXgɓo^Ă邩`FbN */
		if( (*scope)->AddKernel(ker) )
		{
			::LeaveCriticalSection(&cs);
			return (*scope)->bstr;
		}else
		{
		::LeaveCriticalSection(&cs);
		return NULL;
		}
	}
	/* ~[ebNXVɍ쐬ꍇ */
	mutex = new Mutex(id, ker);
	mutex->Create();
	MutexList.push_back(mutex);
	::LeaveCriticalSection(&cs);
	return mutex->bstr;
}

/*
 * \brief ~[ebNX쐬i n[hEFAV~[^̗vj
 * \param[in] id ~[ebNXID
 * \param[in] dev    voCDeviceIuWFNg
 * \retval    bstr   ~[ebNX̖O
 * \retval    NULL   ~[ebNX쐬Ɏsꍇ
 */
BSTR CExeModule::CreateMutex(unsigned long id, class CDevice *dev)
{
	std::list<class Mutex *>::iterator scope;
	class Mutex * mutex;

	::EnterCriticalSection(&cs);
	FindIterator( scope, MutexList.begin(), MutexList.end(),
		(*scope)->id == id );
	/* łɃ~[ebNX쐬Ăꍇ */
	if(scope != MutexList.end())
	{
		/* V~[^~[ebNX̎QƃXgɓo^Ă邩`FbN */
		if( (*scope)->AddDevice(dev) )
		{
			::LeaveCriticalSection(&cs);
			return (*scope)->bstr;
		}else
		{
		::LeaveCriticalSection(&cs);
		return NULL;
		}
	}
	/* ~[ebNXVɍ쐬ꍇ */
	mutex = new Mutex(id, dev);
	mutex->Create();
	MutexList.push_back(mutex);
	::LeaveCriticalSection(&cs);
	return mutex->bstr;
}

/*
 * \brief ~[ebNX폜 i \tgEFAV~[^̗vj
 * \param[in] id     ~[ebNXID
 * \param[in] ker    voCKernelIuWFNg
 */
void CExeModule::CloseMutex(unsigned long id, class CKernel * ker)
{
	std::list<class Mutex *>::iterator scope;

	::EnterCriticalSection(&cs);
	scope = MutexList.begin();
	FindIterator( scope, MutexList.begin(), MutexList.end(),
		(*scope)->id == id );
	/* ~[ebNXȂꍇ */
	if(scope == MutexList.end())
	{
		::LeaveCriticalSection(&cs);
		return;
	}
	/* ~[ebNX̎QƃXg\tgEFAV~[^菜 */
	(*scope)->DeleteKernel(ker);
	if( (*scope)->Close() )
	{
		MutexList.erase(scope);
		delete (*scope);
	}
	::LeaveCriticalSection(&cs);
}

/*
 * \brief ~[ebNX폜i n[hEFAV~[^̗vj
 * \param[in] id     ~[ebNXID
 * \param[in] dev    voCDeviceIuWFNg
 */
void CExeModule::CloseMutex(unsigned long id, class CDevice * dev)
{
	std::list<Mutex *>::iterator scope;

	::EnterCriticalSection(&cs);
	scope = MutexList.begin();
	FindIterator( scope, MutexList.begin(), MutexList.end(),
		(*scope)->id == id );
	/* ~[ebNXȂꍇ */
	if(scope == MutexList.end())
	{
		::LeaveCriticalSection(&cs);
		return;
	}
	/* ~[ebNX̎QƃXgn[hEFAV~[^菜 */
	(*scope)->DeleteDevice(dev);
	if( (*scope)->Close() )
	{
		MutexList.erase(scope);
		delete (*scope);
	}
	::LeaveCriticalSection(&cs);
}

#if 1

/*
 * \brief bN擾
 * Ȃ֐
 * TODO:gpĂȂƂmF
 */
bool CExeModule::AcquireLock(unsigned long address, unsigned long size)
{
	//*res = false;
	std::map<Range, SharedMem *>::iterator scope;
	Range range(address, size);

	::EnterCriticalSection(&cs);
	scope = LockList.begin();
	while(scope != LockList.end())
	{
		if( range.IsIncludedIn((*scope).first) )
		{
			DebugOut(::wsprintfA(Buffer,"Request<AcquireLock>(address=%x, size=%x) failed\n", address, size));
			::LeaveCriticalSection(&cs);
			return false;
		}
		scope++;
	}
	//if(scope == LockList.end())
	{
		std::list<SharedMem *>::iterator scope;
		FindIterator( scope, SharedMemList.begin(), SharedMemList.end(),
			range.IsIncludedIn((*scope)->range) );
		if(scope == SharedMemList.end())
		{
			LockList[range] = NULL;
		}else
		{
			LockList[range] = *scope;
		}
		wchar_t tmp[256];
		swprintf(tmp, _T("lock : (%08x,%08x)"), address, size);
		//CString messag(tmp);
		MessageBox(NULL, tmp, _T("debug"), MB_OK);
		::LeaveCriticalSection(&cs);
		return true;
		//*res = true;
		//if(result){
		//	MessageBox( NULL, _T("Lock Required"), _T("Device Manager"), MB_OK );
		//}
	}
}

/*
 * \brief bN
 * Ȃ֐
 */
bool CExeModule::ReleaseLock(unsigned long address, unsigned long size)
{
	std::map<Range, class SharedMem *>::iterator scope;
	Range range(address, size);

	::EnterCriticalSection(&cs);
	scope = LockList.begin();
	while( scope != LockList.end() )
	{
		if( range.IsIncludedIn((*scope).first) )
		{
			LockList.erase(scope);
			//MessageBox(NULL, _T("bN"), _T("debug"), MB_OK);
			::LeaveCriticalSection(&cs);
			return true;
		}
		scope++;
	}
	//*res = false;
	DebugOut(::wsprintfA(Buffer,"Request<ReleaseLock> not valid address\n"));
	MessageBox(NULL, _T("Released lock failed in DM"), _T("debug"), MB_OK);
	::LeaveCriticalSection(&cs);
	//return;
	return false;
}
#if 0
bool CExeModule::AcquireLock(unsigned long address, unsigned long size)
{
	bool result = false;
	std::list<class SharedMem *>::iterator scope;
	Range range(address, size);

	::EnterCriticalSection(&cs);
	FindIterator( scope, SharedMemList.begin(), SharedMemList.end(),
		range.IsInsideOf((*scope)->range) );
	if(scope != SharedMemList.end())
	{
		result = (*scope)->Lock();
		/*
		if(result){
			MessageBox( NULL, _T("Lock Required"), _T("Device Manager"), MB_OK );
		}
		*/
	}
	::LeaveCriticalSection(&cs);
	return result;
}

bool CExeModule::ReleaseLock(unsigned long address, unsigned long size)
{
	std::list<class SharedMem *>::iterator scope;
	Range range(address, size);

	::EnterCriticalSection(&cs);
	FindIterator( scope, SharedMemList.begin(), SharedMemList.end(),
		range.IsInsideOf((*scope)->range) );
	if(scope != SharedMemList.end())
	{
		(*scope)->Unlock();
		::LeaveCriticalSection(&cs);
		return true;
	}
	::LeaveCriticalSection(&cs);
	return false;
}
#endif
#endif

/*
 * \brief LɃ}bsOꂽAhẌ擾
 * \param[in]  lpName  L̖O
 * \param[out] address }bsOꂽAhẌ̊JnAhX
 * \param[out] size    }bsOꂽAhẌ̃TCYioCgj
 * \retval     true    AhẌ擾ɐ
 * \retval     false   AhẌ擾Ɏs
 */
bool CExeModule::GetMemory(BSTR lpName, unsigned long * address, unsigned long * size)
{
	bool result=false;
	std::map<Range, DevMem *>::iterator scope;

	::EnterCriticalSection(&cs);
	scope = AddressMap.begin();
	/* AhẌ̌ */
	while( scope != AddressMap.end() )
	{
		if( scope->second->memory != NULL )
		{
			if(scope->second->memory->bstr == lpName)
				break;
		}
		scope ++;
	}
	/* AhẌ悪ꍇ */
	if( scope != AddressMap.end() )
	{
		*address = scope->first.GetBase();
		*size    = scope->first.GetLength();
		result = true;
	}
	/* AhẌ悪Ȃꍇ */
	else
	{
		result = false;
	}
	::LeaveCriticalSection(&cs);
	return result;
}
