/*
    toppers_skyeye_mach_at91.c
    Copyright (C) 2006-2009 by Embedded and Real-Time Systems Laboratory
              Graduate School of Information Science, Nagoya Univ., JAPAN

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/* toppers_add at 2008-02-25 */
#define MUTEX_NUM  (3)
/* toppers_add at 2008-02-25 */
extern int toppers_acquire_mutex (unsigned long number);
extern int toppers_release_mutex (unsigned long number);
extern void toppers_raise_interrupt (ARMword intno);
extern void toppers_read_tsc (ARMword * lower, ARMword * higher);
/* toppers_add at 2008-02-25 */
extern CRITICAL_SECTION toppers_cs;
/* toppers_add at 2008-02-25 */
ARMword toppers_int_out_reg;    /* $B3d9~$_=PNO(B */
ARMword toppers_mutex_base;     /* $B%_%e!<%F%C%/%9(B */
ARMword toppers_prc_id_reg;     /* $B%W%m%;%C%5(BID */
ARMword toppers_perf_time_base; /* $B<B;~4V<hF@(B */
ARMword toppers_cycle_counter;  /* $B%5%$%/%k?t<hF@(B */
/* toppers_add at 2008-02-25 */
ARMword toppers_prc_id = -1;    /* $B%W%m%;%C%5(BID */
/* toppers_add at 2010-04-21 */
ARMword toppers_skyeye_version_reg = 0xFFFE1000;  /* skyeye$B$N%P!<%8%g%s(B */
ARMword toppers_devmex_version_reg = 0xFFFE1010;  /* $B%G%P%$%9%^%M!<%8%c$N%P!<%8%g%s(B */

/* toppers_add at 2008-03-21 */
extern ARMword toppers_sync_cycle_base;                     /* $BF14|%5%$%/%k?tJQ99MQ$N%Y!<%9%"%I%l%9(B */
extern void toppers_change_sync_cycles(int changed_cycles); /* $BF14|%5%$%/%k?t$NJQ99$r9T$&(B */
/* toppers_add at 2008-04-01 for log trace */
extern skyeye_config_t skyeye_config;  
extern int toppers_log_trace_base;  /* $B%m%0(BON/OFF$B@Z$jBX$(MQ%Y!<%9%"%I%l%9(B */

/*----------------------------------------------------------------------*/
/* arch/march/skyeye_mach_at91.c:at91_io_read_word()*/
#define	TOPPERS_AT91_IO_READ_WORD                                       \
	if (addr == toppers_int_out_reg) {                                  \
		break;                                                          \
	}                                                                   \
	if (addr == toppers_mutex_base) {                                   \
		data = io.mutex_id;                                             \
		break;                                                          \
	}                                                                   \
	if (addr == (toppers_mutex_base + 4)) {                             \
		/* return '1' if success, or return '0' if failure */           \
		data = toppers_acquire_mutex (io.mutex_id)?1:0;                 \
		break;                                                          \
	}                                                                   \
	if (addr == toppers_prc_id_reg) {                                   \
		data = toppers_prc_id;                                          \
		break;                                                          \
	}                                                                   \
	if (addr == toppers_perf_time_base) {                               \
		toppers_read_tsc (&io.host_time_lo, &io.host_time_hi);          \
		data = io.host_time_lo;                                         \
		break;                                                          \
	}                                                                   \
	if (addr == toppers_perf_time_base + 4) {                           \
		data = io.host_time_hi;                                         \
		break;                                                          \
	}                                                                   \
	if (addr == toppers_cycle_counter) {                                \
      data = state->NumScycles + state->NumNcycles + state->NumIcycles  \
        + state->NumCcycles + state->NumFcycles;                        \
        break;                                                          \
	}                                                                   \
	if (addr == toppers_skyeye_version_reg) {                           \
		data = SKYEYE_VERSION;								            \
        break;                                                          \
	}                                                                   \
	if (addr == toppers_devmex_version_reg) {                           \
		data = DEVMEX_VERSION;											\
        break;                                                          \
	}                                                                   \

/* arch/march/skyeye_mach_at91.c:at91_io_write_word()*/
#define	TOPPERS_AT91_IO_WRITE_WORD                   \
	/* toppers_add at 2008-02-25 */                  \
    if (addr == toppers_int_out_reg) {               \
		toppers_raise_interrupt (data);              \
		break;                                       \
	}                                                \
	if (addr == toppers_mutex_base) {                \
		/* set mutex number */                       \
		io.mutex_id = data;                          \
		break;                                       \
	}                                                \
	if (addr == (toppers_mutex_base + 4)) {          \
		/* release mutex when data '1' is written */ \
		if (data == 1)                               \
		  toppers_release_mutex(io.mutex_id);        \
		break;                                       \
	}                                                \
	if (addr == toppers_prc_id_reg) {                \
		break;                                       \
	}                                                \
	if (addr == toppers_perf_time_base) {            \
		break;                                       \
	}                                                \
	if (addr == toppers_perf_time_base + 4) {        \
		break;                                       \
	}                                                \
	if (addr == toppers_cycle_counter) {             \
		break;                                       \
	}                                                \
    /* toppers_add at 2008-03-21 */                  \
    if (addr == toppers_sync_cycle_base){            \
        toppers_change_sync_cycles(data);            \
        break;                                       \
    }                                                \
	/* toppers_add at 2008-04-02 for log trace */    \
	if (addr == toppers_log_trace_base){             \
		skyeye_config.log.logon= (data&0x0000ffff);  \
		skyeye_config.log.memlogon=((data&0xffff0000)>>4); \
		break;                                       \
	}                                                \
	if (addr == toppers_skyeye_version_reg) {        \
		break;                                       \
	}                                                \
	if (addr == toppers_devmex_version_reg) {        \
		break;                                       \
	}                                                \

/*----------------------------------------------------------------------*/
/* $B%W%m%H%?%$%W@k8@(B */
static void
at91_set_intr (u32 interrupt);
/*
 * toppers_add at 2008-02-25
 * \brief COM$B%9%l%C%I$+$i8F$S=P$5$l$k4X?t(B
 * \param[in]  interrupt := 0 (IRQ0)
 *                          1 (IRQ1)
 *                          2 (IRQ2)
 * $BB>$+$i$N3d9~$_=hM}(B
 */
void
toppers_at91_set_irq_intr (u32 interrupt)
{
	switch (interrupt) {
	case 0:
		at91_set_intr (IRQ_EXT0);
		break;
	case 1:
		at91_set_intr (IRQ_EXT1);
		break;
	case 2:
		at91_set_intr (IRQ_EXT2);
		break;
	default:
		break;
	}
}
