/*
	com_cupport.cpp
    Copyright (C) 2006-2009 by Embedded and Real-Time Systems Laboratory
              Graduate School of Information Science, Nagoya Univ., JAPAN
	
	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
 
*/
#include <stdio.h>
#include <list>
#include <map>
/*
 * VCŎꂽt@C
 * devicemanager.h:foCX}l[WCOMC^[tF[X`
 * devicemanager_i.c:COMID
 * cygwinŎgp邽߂devicemanager_i.cCN[hO
 * __IID_DEFINED__`Kv
 */
#include "devicemanager.h"
#define __IID_DEFINED__
#include "devicemanager_i.c"
/*
 * MODET`Thumb߂gpł
 * IWiSkyEyeARMThumb߂ɑΉꍇ`Kv
 * ȂCThumb߂ɑΉȂꍇ͒`ȂƁD
 */
#ifndef MODET
#define MODET
#endif
/*
 * WX^̓eo͂邽
 */
#include "toppers_armdefs.h"

inline bool check_exit();
void devm_error();


/*
 * (o)
 * AT[gƃfobȌo͂2xɕ
 * assert_out:AT[gp
 * debug_out:fobNp
 */
#if MY_DEBUG > 0
#	define assert_out(fmt, a...)		( printf(fmt, ##a), fflush(stdout) )
#else
#	define assert_out(fmt, a...)
#endif //MY_DEBUG > 0

#if MY_DEBUG > 1
#	define debug_out(fmt, a...)		( printf(fmt, ##a), fflush(stdout) )
#else
#	define debug_out(fmt, a...)
#endif //MY_DEBUG > 1

/*
 * IWiSkyEye̒`
 */
#define u32	unsigned int //skyeye.h
/*
 * vZbT
 * \param[in] interrupt   O݂̎
 */
extern "C"
void toppers_at91_set_irq_intr (u32 interrupt); //skyeye_mach_at91.c
/*
 * CXbhCOMXbh̔rŎgp
 */

CRITICAL_SECTION toppers_cs;


namespace{
	/*
	 * COMXbh
	 * false:COMXbh̏I
	 */
	bool loop_flag = true;
	/*
	 * CXbhCOMXbhԂ̃bZ[W̎
	 */
	enum message_type {
		msg_none,        //NGXgȂ
		msg_read,        //[hvin[hEFAV~[^pj
		msg_write,       //Cgvin[hEFAV~[^pj
		msg_interrupt,   //vZbTԊݗv
		msg_map,         //vZbTIDo^v
		msg_cre_shr_mem, //L쐬v
		msg_cls_shr_mem, //Lv
		msg_cre_mutex,   //~[ebNXIuWFNg쐬v
		msg_cls_mutex,   //~[ebNXIuWFNgv
		msg_quit,        //COMXbhIv
	};

	/*
	 * bZ[WŗvsꍇɁCIKvv
	 * ̃}XN
	 */
	const int ERROR_EXIT_MASK = ( 1 << msg_map ) || ( 1 << msg_cre_shr_mem ) || ( 1 << msg_cre_mutex ) || ( 1 << msg_quit );
	/*
	 * CXbhCOMXbhւ̒ʒm
	 */
	HANDLE message_semaphore;
	/*
	 * COMXbh烁CXbhւ̒ʒm
	 */
	HANDLE done_semaphore;
	/*
	 * COMXbh̐mFp
	 */
	HANDLE com_thread_handle;
	/*************************************/
	class Message * message;/* CXbhCOMXbhւ̃bZ[WieNXj*/
	/*
	 * CXbhCOMXbhւ̃bZ[WieNXj
	 */
	class Message{
	  public:
		/* RXgN^*/
		Message(enum message_type type):
		type(type)
		  {
		  };
		/*
		 * \brief bZ[W̑M
		 * \param[in] str G[o͗p̕
		 * \retval true  M
		 * \retval false Ms
		 */
		bool send_message(char * str){
			message = this;
			ReleaseSemaphore(message_semaphore, 1, NULL);
			WaitForSingleObject(done_semaphore, INFINITE);
			if(message != NULL){
				debug_out("request %s error\n", str);
				return false;
			}
			return true;
		};
		/* bZ[W̎ */
		enum message_type type;
	};
	/*
	 * ǂݍݗvbZ[WNX
	 */
	class ReadMessage: public Message{
	  public:
		ReadMessage(unsigned long address, unsigned long size, byte * buf) :
		Message(msg_read), address(address), size(size), buf(buf)
		  {
		  };
		bool send_message(){
			Message::send_message("read_message");
		};

		unsigned long address; /* AhX */
		unsigned long size;    /* oCg */
		byte * buf;            /* f[^obt@ */
	};
	/*
	 * ݗvbZ[WNX
	 */
	class WriteMessage: public Message{
	  public:
		WriteMessage(unsigned long address, unsigned long size, byte * buf) :
		Message(msg_write), address(address), size(size), buf(buf)
		  {
		  };
		bool send_message(){
			Message::send_message("write_message");
		};

		unsigned long address;/* AhX */
		unsigned long size;   /* oCg */
		byte * buf;           /* f[^obt@ */
	};
	/*
	 * vZbTԊݗvbZ[WNX
	 */
	class InterruptMessage: public Message{
	  public:
		InterruptMessage(unsigned long id) :
		Message(msg_interrupt), id(id)
		  {
		  };
		bool send_message(){
			Message::send_message("interrupt_message");
		};

		unsigned long id; /* vZbTID */
	};
	/*
	 * vZbTIDo^vbZ[WNX
	 */
	class MapMessage: public Message{
	  public:
		MapMessage(unsigned long id) :
		Message(msg_map), id(id)
		  {
		  };
		bool send_message(){
			Message::send_message("map_message");
		};

		unsigned long id;  /*  荞ID(16rbgFvZbTID)
							*            (16rbgF荞ݔԍ)
							*/
	};

	/*
	 * L쐬vbZ[WNX
	 */
	class CreateSharedMemoryMessage: public Message{
	  public:
		CreateSharedMemoryMessage(unsigned long address, unsigned long size, BSTR * name) :
		Message(msg_cre_shr_mem), address(address), size(size), name(name)
		  {
		  };
		bool send_message(){
			Message::send_message("create_shared_memory_message");
		};

		unsigned long address;/* AhX */
		unsigned long size;   /* oCg */
		BSTR * name;          /* L̖OifoCX}l[Wɖj*/
	};
	/*
	 * L폜vbZ[WNX
	 */
	class CloseSharedMemoryMessage: public Message{
	  public:
		CloseSharedMemoryMessage( BSTR name) :
		Message(msg_cls_shr_mem), name(name)
		  {
		  };
		bool send_message(){
			Message::send_message("close_shared_memory_message");
		};

		BSTR name; /* L̖O */
	};
	/*
	 * ~[ebNX쐬vbZ[WNX
	 */
	class CreateMutexMessage: public Message{
	  public:
		CreateMutexMessage(unsigned long id, BSTR * name) :
		Message(msg_cre_mutex), id(id), name(name)
		  {
		  };
		bool send_message(){
			Message::send_message("create_mutex_message");
		};

		unsigned long id;/* ~[ebNXID */
		BSTR * name;     /* ~[ebNX̖OifoCX}l[Wɖj*/
	};
	/*
	 * ~[ebNX폜vbZ[WNX
	 */
	class CloseMutexMessage: public Message{
	  public:
		CloseMutexMessage(unsigned long id) :
		Message(msg_cls_mutex), id(id)
		  {
		  };
		bool send_message(){
			Message::send_message("close_mutex_message");
		};

		unsigned long id;/* ~[ebNXID */
	};
	/*
	 * COMXbhIvbZ[WNX
	 */
	class QuitComMessage: public Message{
	  public:
		QuitComMessage() :
		Message(msg_quit)
		  {
		  };
		bool send_message(){
			Message::send_message("quit_com_message");
		};
	};
	bool test(){
		bool ret;
		byte buf[256];
		class ReadMessage msg(0xffff, 4, buf);
		ret = msg.send_message();
		return ret;
	}

	/*************************************/
	/*
	 * unsigned long:~[ebNXIDiskyeye.confŎwj
	 */
	std::map<unsigned long, HANDLE> mutex_map;
	std::map<unsigned long, int>    mutex_state_map;

	/*
	 * foCX}l[WŊǗn[hEFAV~[^̃AhX
	 * SkyEyeŊǗAhX}bsO邽߂̍\
	 */
	typedef struct {
		unsigned long address;
		unsigned long size;
		unsigned long devm_address;
	} t_devm_address;
	/*
	 * L}bsÔ߂̃Xg
	 */
	std::list<t_devm_address *> devm_address_list;
	/*
	 * LSkyEyeǗAhXɃ}bsO邽߂̍\
	 */
	typedef struct {
		HANDLE handle;
		BSTR * name;
		void * data;
		unsigned long address;
		unsigned long size;
	} t_memory;
	/*
	 * L}bsÔ߂̃Xg
	 */
	std::list<t_memory *> shr_mem_list;
	/*
	 * devm_int_id : vZbTԊݗpID
	 * 0Fݒ
	 */
	unsigned long devm_int_id = 0;
	/*
	 * O݂̐M̐
	 */
	const unsigned int max_irq = 3;
	/*
	 *iskyeye.confŎwj
	 * SkyEyeƃfoCX}l[W̊ݔԍ̃}bsO
	 * ݔԍ̉16rbgsubids[i]CIRQi݂
	 */
	unsigned long sub_ids[max_irq];
	/*
	 * V~[VԂ̑p
	 */
	unsigned long long clock_per_msec=1;
	/*
	 * foCX}l[WCOMʐM󂯂NX
	 * eNXF_IKernelEventsifoCX}l[WŒ`j
	 */
	class KernelEvents : public _IKernelEvents{
	  public:
		KernelEvents(void):n_Refs(0){}
		~KernelEvents(void){}
		/*
		 * STDMETHODIMP_(XXXX)
		 * STDMETHODIMṔCCOM̃C^[tF[X邱ƂD
		 * XXXX́C߂ľ^
		 * COMvO~O̊{IȊ֐D
		 * QƂƂɌĂ΂C
		 * QƃJE^CNgD
		 */
		STDMETHODIMP_(ULONG) AddRef(void){
			return ::InterlockedIncrement(&n_Refs);
		}
		/*
		 * COMvO~O̊{IȊ֐D
		 * QƂKvȂȂꍇ
		 * Ă΂CQƃJE^fNgD
		 */
		STDMETHODIMP_(ULONG) Release(void){
			LONG res = ::InterlockedDecrement(&n_Refs);
			if(res == 0) delete this;
			return res;
		}
		/*
		 * \brief C^[tF[X̗v󂯂֐
		 * \param[in] riid gpC^[tF[XID
		 * \param[in] ppvObject QƑ̃|C^̃|C^
		 * \retval    G[R[h
		 * COMvO~O̊{IȊ֐D
		 * C^[tF[XvC΁CLXgppvObject
		 * DȂꍇ́CG[ԂD
		 */
		STDMETHODIMP QueryInterface(REFIID riid,void **ppvObject){
			if(riid == IID__IKernelEvents){
				*ppvObject = static_cast<_IKernelEvents*>(this);
			}else if(riid == IID_IUnknown){
				*ppvObject = static_cast<IUnknown*>(this);
			}else{
				*ppvObject = NULL;
				return E_NOINTERFACE;
			}
			reinterpret_cast<IUnknown*>(*ppvObject)->AddRef();
			return S_OK;
		}
		/*
		 * \brief ݗv󂯂֐
		 * \param[in] inhno ݃nhԍ
		 *
		 */
		HRESULT STDMETHODCALLTYPE OnInterruptRequest(unsigned long inhno){
			unsigned int interrupt, i;
			interrupt = inhno & 0xffff;

			for(i=0; i<max_irq; i++){
				if(interrupt == sub_ids[i]){
					toppers_at91_set_irq_intr(i);//skyeye_mach_at91.c
					break;
				}
			}
			debug_out("OnInterruptRequest: argument=0x%08x\n", inhno);
			return S_OK;
		}

	  private:
		/*
		 * QƃJE^
		 */
		LONG n_Refs;
	};//end class KernelEvents
	
	bool dev_init = true;
	/*----Xbh----------------------------------------------------*/
	/*
	 * \brief COMXbh
	 * \param[in] param Xbḧ(ł͎gĂȂ)
	 * COMXbhł́CCXbhƃfoCX}l[Wv
	 * CD
	 * CXbhFbZ[W󂯎CfoCX}l[WCOMʐM
	 *                 D
	 * foCX}l[WFCOMʐMŊ֐ĂяoD
	 */
	DWORD WINAPI COMThread(LPVOID param){
		HRESULT res;
		/*
		 * manageŕCfoCX}l[WskyeyeɑΉCOMIuWFNg
		 */
		IKernel *manager;
		IConnectionPointContainer *cpc;
		IConnectionPoint *cp;
		KernelEvents *evnt;
		unsigned long cookie;
		BOOL Success;

		::CoInitialize(NULL);
		/* foCX}l[WƐڑ */
		manager = 0;
		res = ::CoCreateInstance(CLSID_Kernel, 0, CLSCTX_ALL, IID_IKernel, (void **)&manager);
		if(FAILED(res)){
			assert_out("CoCreateInstance error\n");
			dev_init = false;
			return -1;
		}
		cpc = 0;
		res = ((IUnknown*)manager)->QueryInterface(IID_IConnectionPointContainer, (void**)&cpc);
		if(FAILED(res)) assert_out("QueryInterface error");
		/*
		 * foCX}l[WCOMʐM󂯎邽߂COMIuWFNg
		 * ̓o^
		 */
		cp = 0;
		res = cpc->FindConnectionPoint(IID__IKernelEvents, &cp);
		if(FAILED(res)) assert_out("FindConnectionPoint error");
		cpc->Release();
		evnt = new KernelEvents();
		res = cp->Advise(evnt, &cookie);
		if(FAILED(res)) assert_out("Advise error");
		/* foCX}l[WƂ̐ڑ`FbN */
		manager->IsValid(&Success);
		if(Success != 0){
			MSG msg;
			/*
			 *
			 */
			DWORD wait_obj_ret;

			do {
				/*
				 * OCOMƃbZ[WƂĔł邽߁C
				 * WaitForSingleObjectŃZ}tH҂ƊO̗vs
				 * ȂȂD̂߁CMsgWaitFor...pCbZ[W
				 * łꍇ͂ɑΏł悤ɂD
				 */

				/*
				 * QS_ALLPOSTMESSAGE`ȂꍇɑΏD
				 */
#ifndef QS_ALLPOSTMESSAGE
#define QS_ALLPOSTMESSAGE (0x0100)
#endif

				/* v҂ */
				wait_obj_ret = ::MsgWaitForMultipleObjects(1, &message_semaphore, FALSE, INFINITE, QS_ALLPOSTMESSAGE);
				/* ݃bZ[Wdevm_read(devm_write)֐N
				 * eBJZNVɓƊ댯ݏ̎ɒ
				 * 邱
				 */
				::EnterCriticalSection(&toppers_cs);

				switch(wait_obj_ret) {

					/*
					 * WAIT_OBJECT_0:CXbhfoCX}l[Wւ̒
					 * Mv
					 */
				  case WAIT_OBJECT_0:
					//				switch(message.type){
					switch(message->type){
					  case msg_read:
						ReadMessage * read = (ReadMessage *)message;
						res = manager->Read(read->address, read->size, read->buf);
						break;
					  case msg_write:
						WriteMessage * write = (WriteMessage *)message;
						res = manager->Write(write->address, write->size, write->buf);
						break;
					  case msg_interrupt:
						debug_out("COM thread: got interrupt request\n");
						fflush(stdout);
						fflush(stderr);
						InterruptMessage * interrupt = (InterruptMessage *)message;
						debug_out("request id = %x\n", interrupt->id);
						fflush(stdout);
						fflush(stderr);
						res = manager->RaiseInterrupt(interrupt->id);
						break;
					  case msg_map:
						MapMessage * map = (MapMessage *)message;
						res = manager->Map(map->id);
						debug_out("after msg_map:%d\n",res);
						fflush(stdout);
						fflush(stderr);

						break;
					  case msg_cre_shr_mem:
						CreateSharedMemoryMessage * cre_shr_mem = (CreateSharedMemoryMessage *) message;
						res = manager->CreateSharedMemoryAnyName(cre_shr_mem->address, cre_shr_mem->size, cre_shr_mem->name);

						break;
					  case msg_cls_shr_mem:
						CloseSharedMemoryMessage * cls_shr_mem = (CloseSharedMemoryMessage *) message;
						res = manager->ReleaseSharedMemory(cls_shr_mem->name);
						break;
					  case msg_cre_mutex:
						CreateMutexMessage * cre_mutex = (CreateMutexMessage *) message;
						res = manager->CreateMutex(cre_mutex->id, cre_mutex->name);
						break;
					  case msg_cls_mutex:
						CloseMutexMessage * cls_mutex = (CloseMutexMessage *) message;
						res = manager->CloseMutex(cls_mutex->id);
						break;
					  case msg_quit:
						res = S_OK;
						loop_flag = false;
						break;
					  default:
						break;
					}

					/* ʐMEG[o */
					if(SUCCEEDED(res)){
						message = NULL;
					}else{
						loop_flag = check_exit();
						devm_error();
					}

					::LeaveCriticalSection(&toppers_cs);
					ReleaseSemaphore(done_semaphore, 1, NULL);
					break;

					/*
					 * WAIT_OBJECT_0 + 1:O̗v (݂Ȃ)
					 * foCX}l[W烁CXbhւ̒ʐMv
					 */
				  case WAIT_OBJECT_0 + 1:
					::LeaveCriticalSection(&toppers_cs);
					/*
					 * DispatchMessage(&msg)Ă΂ƃbZ[WɉR[
					 * obN֐(RPCɑ)Ă΂D
					 * ̏ꍇ́COnInterruptRequest()Ă΂D
					 */
					GetMessage(&msg, 0, 0, 0);
					TranslateMessage(&msg);
					DispatchMessage(&msg);
					break;

				  default:
					::LeaveCriticalSection(&toppers_cs);
					loop_flag = false;
					break;
				}
			} while(loop_flag);
		}

		/* COMXbhƃfoCX}l[Wؒf*/
		cp->Unadvise(cookie);
		cp->Release(); //cpevntRelease()Ă΂

		/* foCX}l[Wւ̃vZbTID̓o^*/
		if(devm_int_id != 0){
			res = manager->Unmap(devm_int_id);
			if(FAILED(res))
			  assert_out("Unmap error");
		}
		manager->Release();
		/* COMXbh̏I */
		::CoUninitialize();
		return 0;
	}
}

/*
 * \brief G[ɏIKvṽ`FbN
 * \retval true:IKvȂꍇ
 *         false:IKvꍇ
 */
inline bool check_exit(){
	if((1 << message->type) & ERROR_EXIT_MASK ){
		return false;
	}
	return true;
}


/*
 * \brief foCX}l[WCOMʐM̃G[
 * \param[in] CXbhCOMXbh̃bZ[W
 *
 */
void devm_error(){
	switch(message->type){
	  case msg_read:
		ReadMessage * read = (ReadMessage *)message;
		debug_out("devm_read(address=0x%08x, size=%d) failed\n",
				  read->address, read->size);
		break;
	  case msg_write:
		WriteMessage * write = (WriteMessage *)message;
		debug_out("devm_write(address=0x%08x, size=%d) failed\n",
				  write->address, write->size);
		break;
	  case msg_interrupt:
		InterruptMessage * interrupt = (InterruptMessage *)message;
		assert_out("devm_raise_interrupt(0x%08x) failed\n", interrupt->id);
		break;
	  case msg_map:
		MapMessage * map = (MapMessage *)message;
		assert_out("devm_map(id=0x%08x) failed\n", map->id);
		break;
	  case msg_cre_shr_mem:
		CreateSharedMemoryMessage * cre_shr_mem = (CreateSharedMemoryMessage *) message;
		assert_out("devm_create_shared_memory(address=0x%08x, size=0x%x) failed\n",
				   cre_shr_mem->address, cre_shr_mem->size);
		break;
	  case msg_cls_shr_mem:
		assert_out("devm_close_shared_memory failed\n");
		break;
	  case msg_cre_mutex:
		CreateMutexMessage * cre_mutex = (CreateMutexMessage *) message;
		assert_out("devm_create_mutex(id=0x%08x) failed\n", cre_mutex->id);
		break;
	  case msg_cls_mutex:
		CloseMutexMessage * cls_mutex = (CloseMutexMessage *) message;
		assert_out("devm_close_mutex(id=0x%08x) failed\n", cls_mutex->id);
		break;
	  case msg_quit:
		assert_out("toppers_com_quit failed\n");
		break;
	}
}

//CXbhCOMXbhɗvo֐QiubLOʐMj----//
/*
 * \brief n[hEFAV~[^̃}bsOꂽf[^̓ǂݍ
 * \param[in] address n[hEFAV~[^̃AhX
 * \param[in] size    ANZXTCYioCgj
 * \param[in] buf     󂯎f[^p̃obt@
 * \retval    true    COMʐM̐
 * \retval    false   COMʐM̎s
 */
bool devm_read(unsigned long address, unsigned long size, char * buf){
	class ReadMessage msg(address, size, (byte *)buf);
	return msg.send_message();
}
/*
 * \brief n[hEFAV~[^̃}bsOꂽf[^̏
 * \param[in] address n[hEFAV~[^̃AhX
 * \param[in] size    ANZXTCYioCgj
 * \param[in] buf     ݃f[^p̃obt@
 * \retval    true    COMʐM̐
 * \retval    false   COMʐM̎s
 */
bool devm_write(unsigned long address, unsigned long size, char * buf){
	class WriteMessage msg(address, size, (byte *)buf);
	return msg.send_message();
}
/*
 * \brief vZbTԊ荞
 * \param[in] id      荞ID(16rbgFvZbTID)
 *                              (16rbgF荞ݔԍ)
 * \retval    true    COMʐM̐
 * \retval    false   COMʐM̎s
 */
bool devm_raise_interrupt(unsigned long id){
	class InterruptMessage msg(id);
	return msg.send_message();
}
/*
 * \brief foCX}l[Wւ̃vZbTID̓o^
 * \param[in] id      vZbTID
 * \retval    true    COMʐM̐
 * \retval    false   COMʐM̎s
 */
bool devm_map(unsigned long id){
	class MapMessage msg(id);
	return msg.send_message();
}
/*
 * \brief L쐬v
 * \param[in] address L̊JnAhX
 * \param[in] size    TCYioCgj
 * \param[in] name    Lɑ΂ăfoCX}l[W閼O
 * \retval    true    COMʐM̐
 * \retval    false   COMʐM̎s
 */
bool devm_create_shared_memory(unsigned long address, unsigned long size, BSTR * name){
	class CreateSharedMemoryMessage msg(address, size, name);
	return msg.send_message();
}
/*
 * \brief L̉
 * \param[in] name    Lɑ΂ăfoCX}l[WO
 * \retval    true    COMʐM̐
 * \retval    false   COMʐM̎s
 */
bool devm_close_shared_memory(BSTR name){
	class CloseSharedMemoryMessage msg(name);
	return msg.send_message();
}
/*
 * \brief ~[ebNX쐬v
 * \param[in] id   r  foCX}l[WǗ~[ebNXID
 * \param[in] name    ~[ebNXɑ΂ăfoCX}l[W쐬閼O
 * \retval    true    COMʐM̐
 * \retval    false   COMʐM̎s
 */
bool devm_create_mutex(unsigned long id, BSTR * name){
	class CreateMutexMessage msg(id, name);
	return msg.send_message();
}
/*
 * \brief ~[ebNX̉
 * \param[in] id      foCX}l[WǗ~[ebNXID
 * \retval    true    COMʐM̐
 * \retval    false   COMʐM̎s
 */

bool devm_close_mutex(unsigned long id){
	class CloseMutexMessage msg(id);
	return msg.send_message();
}
/*
 * \brief COMXbhɃXbhIvo֐imubLOʐMj
 */
bool toppers_com_quit(void){
	if(!dev_init) return false;
	class QuitComMessage msg;
	return msg.send_message();
}

/*
 * \brief COMXbh֐
 */
void toppers_initialize_com_thread(void){
	::InitializeCriticalSection(&toppers_cs);
	message_semaphore = ::CreateSemaphore(0, 0, 1, 0);
	done_semaphore = ::CreateSemaphore(0, 0, 1, 0);
	/* bZ[W̏ */
	message = NULL;
	com_thread_handle = ::CreateThread(0, 0, COMThread, 0, 0, 0);
}

void close_shared_memory(void);
void close_mutex(void);
/*
 * COMXbh̏I֐
 */
extern "C"
void _cdecl toppers_quit_com_thread(void){
	close_shared_memory();
	close_mutex();

	if(com_thread_handle != NULL){
		if(loop_flag){
			toppers_com_quit();
		}
		::WaitForSingleObject(com_thread_handle, INFINITE);
	}
	::CloseHandle(done_semaphore);
	::CloseHandle(message_semaphore);
	::DeleteCriticalSection(&toppers_cs);
}

/*
 * \brief SkyEyẽԂCfoCX}l[W̃ԂɃ}b
 *        sO
 * \param[in] address     SkyEyẽAhX
 * \param[in] size        }bsOTCYioCgj
 * \param[in] devm_address foCX}l[W̃AhX
 */
extern "C"
void _cdecl toppers_set_devm_address (unsigned long address, unsigned long size, unsigned long devm_address){
	t_devm_address * addr_map;
	std::list<t_devm_address *>::iterator scope;

	/* COMԂ̏d`FbN*/
	scope = devm_address_list.begin();
	while(scope != devm_address_list.end()){
		if( (*scope)->devm_address < (devm_address + size)
			&& devm_address < ((*scope)->devm_address + (*scope)->size) ){
			assert_out("devm_address_set: warning: COM address spaces are overlapped\n");
			assert_out("\taddress=0x%08x, size=0x%08x <--> address=0x%08x, size=0x%08x\n",
					   (*scope)->devm_address, (*scope)->size, devm_address, size);
			break;
		}
		scope ++;
	}
	/* Xgɒǉ */
	addr_map = new t_devm_address;
	addr_map->address     = address;
	addr_map->size        = size;
	addr_map->devm_address = devm_address;
	devm_address_list.push_back(addr_map);
}
/*
 * \brief addressn܂sizeoCg̋L쐬CmemɃ}bs
 *        O
 * \param[in] address     SkyEyẽAhX
 * \param[in] size        }bsOTCYioCgj
 * \param[in] devm_address foCX}l[W̃AhX
 */
extern "C"
void _cdecl toppers_create_shared_memory (unsigned long address, unsigned long size, unsigned long devm_address){
	t_memory * memory;
	BSTR * pbstr;
#define BUF_SIZE 256
	char buf[BUF_SIZE];
	int len;
	memory = new t_memory;
	if(memory == NULL){
		printf("new t_memory failed\n");
		return;
	}
	pbstr = new BSTR;
	/*
	 * L̍쐬
	 * L̍쐬ɎsƁCV~[VłȂ̂ŏI
	 * D
	 */
	if( !devm_create_shared_memory(devm_address, size, pbstr) ){
		assert_out("create_shared_memory: Device Manager returned an error code.\n");
		delete pbstr;
		delete memory;
		toppers_quit_com_thread();
		exit(-1);
	}
	if(*pbstr == NULL){
		assert_out("create_shared_memory: BSTR points NULL\n");
		delete pbstr;
		delete memory;
		exit(-1);
	}

	len = SysStringLen(*pbstr);
	if( len >= BUF_SIZE || len == 0 ){
		assert_out("create_shared_memory: Device Manager returned a string whose length is invalid(%d).\n",len);
		devm_close_shared_memory( *pbstr );
		toppers_quit_com_thread();
		exit(-1);
	}

	memory->name = pbstr;
	wsprintf(buf, "%ls", *(memory->name));
	debug_out("CreateSharedMemory (0x%08x, 0x%08x) : \"%s\"\n", devm_address, size, buf);
	/* LI[v */
	memory->handle = ::OpenFileMapping(FILE_MAP_ALL_ACCESS, true, static_cast<LPCTSTR>(buf));
	if(memory->handle == NULL){
		assert_out("OpenFileMapping: could not open mapped file \"%s\"\n", buf);
		devm_close_shared_memory(*pbstr);
		toppers_quit_com_thread();
		::SysFreeString(*pbstr);
		delete pbstr;
		delete memory;
		exit(-1);
	}
	/* I[vLɃ}bsO*/
	memory->data = ::MapViewOfFile(memory->handle, FILE_MAP_ALL_ACCESS, 0, 0, 0);
	if(memory->data == NULL){
		assert_out("MapViewOfFile: could not map file \"%s\"\n", buf);
		devm_close_shared_memory(*pbstr);
		toppers_quit_com_thread();
		::CloseHandle(memory->handle);
		::SysFreeString(*pbstr);
		delete pbstr;
		delete memory;
		exit(-1);
	}
	/* Xgɒǉ */
	memory->address = address;
	memory->size = size;
	shr_mem_list.push_back(memory);
}
/*
 * \brief LSĉ
 */
void close_shared_memory (void){
	std::list<t_memory *>::iterator scope, tmp;

	scope = shr_mem_list.begin();
	while(scope != shr_mem_list.end()){
		devm_close_shared_memory(*((*scope)->name));
		::UnmapViewOfFile((*scope)->data);
		::CloseHandle((*scope)->handle);
		tmp = scope;
		scope++;
		::SysFreeString(*(*tmp)->name);
		delete (*tmp)->name;
		delete *tmp;
	}
}
/*
 * \brief numberŎw肳ꂽID̃~[ebNXIuWFNgpӂ
 * \param[in] number    ~[ebNXID
 */
extern "C"
void _cdecl toppers_create_mutex (unsigned long number){
	unsigned long i;
	BSTR * pbstr;
	char buf[BUF_SIZE];
	int len;
	HANDLE h_mutex;

	if(mutex_map.find(number) != mutex_map.end()){
		assert_out("create_mutex: mutex(%d) is already exist.\n", number);
		return;
	}
	pbstr = new BSTR;
	/*
	 * ~[ebNX̍쐬
	 * ~[ebNX̍쐬ɎsƁCV~[VłȂ̂
	 * ID
	 */
	if( !devm_create_mutex(number, pbstr) ){
		assert_out("create_mutex: Device Manager returned an error code.\n", number);
		toppers_quit_com_thread();
		exit(-1);
	}
	len = SysStringLen(*pbstr);
	if( len >= BUF_SIZE || len == 0 ){
		assert_out("create_mutex: Device Manager returned a string whose length is invalid(%d).\n",len);
		devm_close_mutex( number );
		toppers_quit_com_thread();
		exit(-1);
	}
	wsprintf(buf, "%ls", *pbstr);
	/* ~[ebNXI[v */
	h_mutex = ::OpenMutex(MUTEX_ALL_ACCESS, false, static_cast<LPCTSTR>(buf));
	if(h_mutex == NULL){
		assert_out("cannot open mutex object \"%s\"\n", buf);
		devm_close_mutex( number );
		toppers_quit_com_thread();
		exit(-1);
	}else{
		mutex_map[number] = h_mutex;
		mutex_state_map[number] = 0; /*  */
		debug_out("OpenMutex \"%s\" = %lu\n", buf, (unsigned long)h_mutex);
	}
	/* foCX}l[WŊmۂ̉*/
	::SysFreeString(*pbstr);
	delete pbstr;
}

/*
 * \brief ~[ebNXIuWFNgSĉ
 */
void close_mutex (void){
	unsigned long i;
	std::map<unsigned long, HANDLE>::iterator scope;
	HANDLE h_mutex;

	scope = mutex_map.begin();
	while(scope != mutex_map.end()){
		devm_close_mutex(scope->first);
		::CloseHandle(scope->second);
		debug_out("CloseHandle(mutex) (%lu)\n", (unsigned long)(scope->first) );
		mutex_state_map[scope->first] = 0; /*  */
		scope++;
	}
	mutex_map.clear();
}
/*
 * \brief foCX}l[WɃvZbTIDo^
 * \param[in] id vZbTID
 */
extern "C"
int _cdecl toppers_devm_set_id (unsigned long id){
	/* łɃfoCX}l[Wɓo^Ă邩mF*/
	if(devm_int_id == 0){
		if(devm_map(id)){
			devm_int_id = id;
			return 1;
		}else{
			toppers_quit_com_thread();
			exit(-1);
		}
	}
	return 0;
}
/*
 * \brief SkyEyeƃfoCX}l[W̊ݔԍ̃}bsO
 * \param[in] subid foCX}l[W瑗Ă銄ID̉16rbg
 * \param[in] irq   SkyEyeł̊Oݔԍ
 */
extern "C"
void _cdecl toppers_devm_map_subid (unsigned long subid, unsigned int irq){
	if(irq < max_irq){
		sub_ids[irq] = subid;
	}
}

////// ȉSkyEyep̃ANZX֐ //////
/*
 * \brief SkyEyefoCX}l[WփAhXϊ
 * \param[in] state    vZbT̏
 * \param[in] addr     SkyEyeォAv猩AhX
 * \param[in] ret_addr foCX}l[WǗAhX
 */
bool devm_address (ARMul_State * state, unsigned long addr, unsigned long * ret_addr){
	static t_devm_address * prev = NULL;
	std::list<t_devm_address *>::iterator scope;

	if(prev == NULL || addr < prev->address || prev->address + prev->size <= addr){
		scope = devm_address_list.begin();
		while(scope != devm_address_list.end()){
			if((*scope)->address <= addr && addr < (*scope)->address + (*scope)->size){
				prev = (*scope);
				break;
			}
			scope++;
		}
		if(scope == devm_address_list.end()){
			return false;
		}
	}
	/* Lȃ|C^ǂmF*/
	if(ret_addr != NULL){
		*ret_addr = prev->devm_address + (addr - prev->address);
		return true;
	}
	debug_out("devm_address:ret_addr is invalid address (NULL) \n");
	return false;
}

const ARMword devm_read_fail=0;
/*
 * \brief n[hEFAV~[^̃f[^̓ǂݍ݁ioCgj
 * \param[in] state vZbT̏
 * \param[in] addr  SkyEyẽAv猩AhX
 * \retval data ǂݍ񂾃f[^
 * \retval devm_read_fail ǂݍ݂̎s
 */
extern "C"
ARMword _cdecl toppers_devm_read_byte (ARMul_State * state, ARMword addr){
	unsigned long devm_addr;
	ARMword data;
	if(devm_address(state, addr, &devm_addr)){
		if(devm_read(devm_addr, 1, (char *)&data)){
			return data;
		}
	}
	assert_out("COM read byte error: pc=0x%08x, address=0x%08x(COM address = 0x%08x)\n",
			   state->pc, addr, devm_addr);
	return devm_read_fail;
}
/*
 * \brief n[hEFAV~[^̃f[^̓ǂݍ݁in[t[h)
 * \param[in] state vZbT̏
 * \param[in] addr  SkyEyẽAv猩AhX
 * \retval data ǂݍ񂾃f[^
 * \retval devm_read_fail ǂݍ݂̎s
 */
extern "C"
ARMword _cdecl toppers_devm_read_halfword (ARMul_State * state, ARMword addr){
	unsigned long devm_addr;
	ARMword data;
	if(devm_address(state, addr, &devm_addr)){
		if(devm_read(devm_addr, 2, (char *)&data)){
			return data;
		}
	}
	assert_out("COM read halfword error: pc=0x%08x, address=0x%08x(COM address = 0x%08x)\n",
			   state->pc, addr, devm_addr);
	return devm_read_fail;
}
/*
 * \brief n[hEFAV~[^̃f[^̓ǂݍ݁i[h)
 * \param[in] state vZbT̏
 * \param[in] addr  SkyEyẽAv猩AhX
 * \retval data ǂݍ񂾃f[^
 * \retval devm_read_fail ǂݍ݂̎s
 */
extern "C"
ARMword _cdecl toppers_devm_read_word (ARMul_State * state, ARMword addr){
	unsigned long devm_addr;
	ARMword data;
	if(devm_address(state, addr, &devm_addr)){
		if(devm_read(devm_addr, 4, (char *)&data)){
			return data;
		}
	}
	assert_out("COM read word error: pc=0x%08x, address=0x%08x(COM address = 0x%08x)\n",
			   state->pc, addr, devm_addr);
	return devm_read_fail;
}
/*
 * \brief n[hEFAV~[^̃f[^̏݁ioCg)
 * \param[in] state vZbT̏
 * \param[in] addr  SkyEyẽAv猩AhX
 * \param[in] data  ݃f[^
 */
extern "C"
void _cdecl toppers_devm_write_byte (ARMul_State * state, ARMword addr, ARMword data){
	unsigned long devm_addr;
	if(devm_address(state, addr, &devm_addr)){
		if(devm_write(devm_addr, 1, (char *)&data)){
			return;
		}
	}
	assert_out("COM write byte error: pc=0x%08x, address=0x%08x(COM address = 0x%08x)\n",
			   state->pc, addr, devm_addr);
}
/*
 * \brief n[hEFAV~[^̃f[^̏݁in[t[h)
 * \param[in] state vZbT̏
 * \param[in] addr  SkyEyẽAv猩AhX
 * \param[in] data  ݃f[^
 */
extern "C"
void _cdecl toppers_devm_write_halfword (ARMul_State * state, ARMword addr, ARMword data){
	unsigned long devm_addr;
	if(devm_address(state, addr, &devm_addr)){
		if(devm_write(devm_addr, 2, (char *)&data)){
			return;
		}
	}
	assert_out("COM write halfword error: pc=0x%08x, address=0x%08x(COM address = 0x%08x)\n",
			   state->pc, addr, devm_addr);
}
/*
 * \brief n[hEFAV~[^̃f[^̏݁i[h)
 * \param[in] state vZbT̏
 * \param[in] addr  SkyEyẽAv猩AhX
 * \param[in] data  ݃f[^
 */
extern "C"
void _cdecl toppers_devm_write_word (ARMul_State * state, ARMword addr, ARMword data){
	unsigned long devm_addr;
	if(devm_address(state, addr, &devm_addr)){
		if(devm_write(devm_addr, 4, (char *)&data)){
			return;
		}
	}
	assert_out("COM write word error: pc=0x%08x, address=0x%08x(COM address = 0x%08x)\n",
			   state->pc, addr, devm_addr);
}
/*
 * \brief CXbhCOMXbhփvZbTԊݗv
 * \param[in] intno ID
 */
extern "C"
void _cdecl toppers_raise_interrupt (ARMword intno){
	devm_raise_interrupt((unsigned long)intno);
}

/*
 * \brief ~[ebNX擾֐imubLOj
 * \param[in] number ~[ebNXID
 * \retval 1 擾
 * \retval 0 擾s
 */
extern "C"
int _cdecl toppers_acquire_mutex (unsigned long number){
	int res;
	std::map<unsigned long, HANDLE>::iterator scope;

	scope = mutex_map.find(number);
	if(scope == mutex_map.end()){
		debug_out("acquire_mutex: mutex(%d) is not registered.\n", number);
		return 0;
	}
	/* łɎg擾Ăꍇ͎擾s */
	if ( mutex_state_map[scope->first] == 1){
		return 0;
	}
	/* ~[ebNXID҂ */
	res = ::WaitForSingleObject(scope->second, 0);
	if(res == WAIT_TIMEOUT){
		return 0;
	}else{
		/* WAIT_ABANDONEDiXbhɏIj̏ꍇ܂ */
		debug_out("got mutex%d\n",number);
		mutex_state_map[scope->first] = 1; /* 擾 */
		return 1;
	}
}
/*
 * \brief ~[ebNX֐
 * \param[in] number ~[ebNXID
 * \retval 0 ID
 * \retval 1 
 */
extern "C"
int _cdecl toppers_release_mutex (unsigned long number){
	std::map<unsigned long, HANDLE>::iterator scope;

	scope = mutex_map.find(number);
	if(scope == mutex_map.end()){
		debug_out("release_mutex: mutex(%d) is not registered.\n", number);
		return 0;
	}
	ReleaseMutex(scope->second);
	debug_out("released mutex%d\n", number);
	mutex_state_map[scope->first] = 0; /*  */
	return 1;
}


//LANZX֐Q
//ARM7TDMI̓oCGfBAȂ̂ŁCf[^̕ϊKv
/*
 * \brief SkyEyeWindows̃AhX֕ϊ
 * \param[in] addr SkyEyẽAv猩AhX
 * \retval ret  Windows̃AhX
 * \retval NULL addrLɃ}bsOꂽAhXł͂Ȃ
 */
ARMword * shared_memory (ARMword addr){
	static t_memory * mem = *shr_mem_list.begin();
	std::list<t_memory *>::iterator scope;
	ARMword * ret;

	if(addr < mem->address || mem->address + mem->size <= addr){
		scope = shr_mem_list.begin();
		while(scope != shr_mem_list.end()){
			if((*scope)->address <= addr && addr < (*scope)->address + (*scope)->size){
				mem = *scope;
				break;
			}
			scope++;
		}
		if(scope == shr_mem_list.end()){
			return NULL;
		}
	}
	ret = (ARMword *)mem->data;
	if(ret != NULL){
		ret += (addr - mem->address)/sizeof(unsigned long);
	}
	return ret;
}
/*
 * \brief L̃f[^̓ǂݍ݁ioCg)
 * \param[in] state vZbT̏
 * \param[in] addr  SkyEyẽAv猩AhX
 * \retval ǂݍ񂾃f[^
 * \retval 0 ǂݍݎs
 */
extern "C"
ARMword _cdecl toppers_shmem_read_byte (ARMul_State * state, ARMword addr){
	ARMword ret, *mem;
	unsigned int offset;

	mem = shared_memory(addr);
	if(mem != NULL){
		ret = *mem;
		offset = (((ARMword) state->bigendSig * 3) ^ (addr & 3)) << 3;	/* bit offset into the word */
		return (ret >> offset) & 0xffL;
	}else{
		return 0;
	}
}
/*
 * \brief L̃f[^̓ǂݍ݁in[t[h)
 * \param[in] state vZbT̏
 * \param[in] addr  SkyEyẽAv猩AhX
 * \retval ǂݍ񂾃f[^
 * \retval 0 ǂݍݎs
 */
extern "C"
ARMword _cdecl toppers_shmem_read_halfword (ARMul_State * state, ARMword addr){
	ARMword ret, *mem;
	unsigned int offset;

	mem = shared_memory(addr);
	if(mem != NULL){
		ret = *mem;
		offset = (((ARMword) state->bigendSig * 2) ^ (addr & 2)) << 3;	/* bit offset into the word */
		return (ret >> offset) & 0xffffL;
	}else{
		return 0;
	}
}
/*
 * \brief L̃f[^̓ǂݍ݁i[h)
 * \param[in] state vZbT̏
 * \param[in] addr  SkyEyẽAv猩AhX
 * \retval ǂݍ񂾃f[^
 * \retval 0 ǂݍݎs
 */
extern "C"
ARMword _cdecl toppers_shmem_read_word (ARMul_State * state, ARMword addr){
	ARMword * mem;

	mem = shared_memory(addr);
	if(mem != NULL){
		return *mem;
	}else{
		return 0;
	}
}
/*
 * \brief L̃f[^̏݁ioCg)
 * \param[in] state vZbT̏
 * \param[in] addr  SkyEyẽAv猩AhX
 * \param[in] data  ݃f[^
 */
extern "C"
void _cdecl toppers_shmem_write_byte (ARMul_State * state, ARMword addr, ARMword data){
	ARMword *mem;
	unsigned int offset;

	mem = shared_memory(addr);
	if(mem != NULL){
		offset = (((ARMword) state->bigendSig * 3) ^ (addr & 3)) << 3;	/* bit offset into the word */
		*mem = (*mem & ~(0xffL << offset)) | ((data & 0xffL) << offset);
	}
}
/*
 * \brief L̃f[^̏݁in[t[h)
 * \param[in] state vZbT̏
 * \param[in] addr  SkyEyẽAv猩AhX
 * \param[in] data  ݃f[^
 */
extern "C"
void _cdecl toppers_shmem_write_halfword (ARMul_State * state, ARMword addr, ARMword data){
	ARMword *mem;
	unsigned int offset;

	mem = shared_memory(addr);
	if(mem != NULL){
		offset = (((ARMword) state->bigendSig * 2) ^ (addr & 2)) << 3;	/* bit offset into the word */
		*mem = (*mem & ~(0xffffL << offset)) | ((data & 0xffffL) << offset);
	}
}
/*
 * \brief L̃f[^̏݁i[h)
 * \param[in] state vZbT̏
 * \param[in] addr  SkyEyẽAv猩AhX
 * \param[in] data  ݃f[^
 */
extern "C"
void _cdecl toppers_shmem_write_word (ARMul_State * state, ARMword addr, ARMword data){
	ARMword *mem;

	mem = shared_memory(addr);
	if(mem != NULL){
		*mem = data;
	}
}

//\]p֐
/*
 * \brief Skyeyew肵vZbTŃV~[V
 * \param[in] id zXgPC̃vZbTID
 * \retval 1 vZbTw̐
 * \retval 0 vZbTw̎s
 */
extern "C"
int _cdecl toppers_set_affinity (unsigned long id){
	DWORD aff_prc, aff_sys;
	DWORD set_mask;

	if(!GetProcessAffinityMask(GetCurrentProcess(), &aff_prc, &aff_sys)){
		printf("set_affinity: failed to get system affinity mask\n");
		return 0;
	}
	set_mask = 1 << id;
	/* w肳ꂽvZbTID̑݊mF*/
	if( (set_mask & aff_sys) == 0 ){
		assert_out("set_affinity: id(%d) is invalid\n", id);
		return 0;
	}
	if(SetProcessAffinityMask(GetCurrentProcess(), set_mask) == 0){
		assert_out("set_affinity: failed to set process affinity (id=%d, mask=0x%08x)\n", id, 1<<id);
		return 0;
	}else{

		return 1;
	}
}

/*
 * \brief  zXgPCNẴNbNTCN擾
 * \retval zXgPCNẴNbNTCN
 * RDTSC߂gȂzXg}Vł͎gpłȂ
 */
inline unsigned long long __fastcall rdtsc(void){
	__asm("cpuid");
	__asm("rdtsc");
}
/*
 * \brief zXgPCNẴNbNTCN擾
 * \param[in] lower  NbNTCŃi32rbgj
 * \param[in] higher NbNTCŃi32rbgj
 */
extern "C"
void _cdecl toppers_read_tsc (unsigned long * lower, unsigned long * higher){
	unsigned long long tsc;
	/* NbNTCN擾*/
	tsc = rdtsc();
	tsc /= clock_per_msec;
	*lower = tsc & 0xffffffff;
	*higher = tsc >> 32;
}

/*
 * \brief   zXgvZ@̃NbNg𑪒
 */
extern "C"
void _cdecl toppers_calc_clock_freq (){
	unsigned long hi1, lo1, hi2, lo2;
	DWORD t1, t2;
	long long tmp;

	/* JnVXe擾 => t1 */
	t2 = ::timeGetTime();
	do{
		t1 = ::timeGetTime();
	}while(t1==t2);
	toppers_read_tsc(&lo1, &hi1);
	/* 1b҂ */
	do{
		t2 = ::timeGetTime();
	}while(t1 + 1000 > t2);
	toppers_read_tsc(&lo2, &hi2);
	tmp = ((unsigned long long)(hi2-hi1) << 32) + lo2-lo1;
	clock_per_msec = tmp / (t2 - t1);
	debug_out("clock = %llu , time = %lu (msec) , clock/msec = %lu\n", tmp, t2-t1, clock_per_msec);
}
/*
 * toppers_add at 2008-03-21 for synchronous
 */
#define NUM_ISS_MAX 4                       /* ISS̍ől */
#define DEFAULT_SYNC_CYCLES 1000            /* TCNԊũftHgl */
extern unsigned int toppers_prc_id;         /* vZbTID */
unsigned long toppers_sync_cycles;          /* TCNԊu */
unsigned long toppers_next_sync_cycles;     /* n_̃TCNiݐρj */
HANDLE toppers_current_num_iss_semaphore;   /* ݑ҂ԂISSێ鋤Lϐ̔rɎgp */
HANDLE current_num_iss_hd;                  /* ݑ҂ԂISSێ鋤Lϐp̃nh */
int toppers_sync_enable;                    /* @\̗L/𔻒f邽߂̃tO */
DWORD  *toppers_current_num_iss;            /* ݑ҂ԂISSێ鋤Lϐ */
HANDLE toppers_sync_semaphore[NUM_ISS_MAX]; /* p̑҂IuWFNg */
int toppers_num_iss;                        /* ISSێ */
/* change synchronous */
ARMword toppers_sync_cycle_base;            /* TCNύXp̃x[XAhX */
HANDLE temp_changed_sync_cycles_hd;         /* TCN̕ύXɗpꎞϐp̃nh */
DWORD *toppers_temp_changed_sync_cycles;    /* TCN̕ύXɗpꎞϐ */
HANDLE changed_sync_cycles_hd;              /* TCN̕ύXɗpϐp̃nh */
DWORD *toppers_changed_sync_cycles;         /* TCN̕ύXɗpϐ */
HANDLE end_num_iss_hd;                      /* IISS̐ێ鋤Lϐp̃nh */
DWORD *toppers_end_num_iss;                 /* IISS̐ێ鋤Lϐ */
/*
 * \brief n_̏s
 */
extern "C"
void _cdecl toppers_sync(){
	int i;
	WaitForSingleObject(toppers_current_num_iss_semaphore,INFINITE);
	/* I */
	if(*toppers_end_num_iss > 0){
		toppers_sync_enable=FALSE;
		ReleaseSemaphore(toppers_current_num_iss_semaphore,1,NULL);
	}/* SISSn_ */
	else  if(*toppers_current_num_iss == toppers_num_iss-1){
		*toppers_current_num_iss=0;
		*toppers_changed_sync_cycles = *toppers_temp_changed_sync_cycles;
		ReleaseSemaphore(toppers_current_num_iss_semaphore,1,NULL);
		for(i=0;i<toppers_num_iss;i++){
			if(i!=toppers_prc_id){
				ReleaseSemaphore(toppers_sync_semaphore[i],1,NULL);
			}
		}
	} /* n_ISS */
	else{
		*toppers_current_num_iss+=1;
		ReleaseSemaphore(toppers_current_num_iss_semaphore,1,NULL);
		WaitForSingleObject(toppers_sync_semaphore[toppers_prc_id],INFINITE);
	}
	/* TCN̍XV */
	toppers_sync_cycles = *toppers_changed_sync_cycles;
	toppers_next_sync_cycles += toppers_sync_cycles;
}
/*
 * \brief @\pLIuWFNg쐬
 */
extern "C"
void _cdecl toppers_make_shared_object(void){
	int i;
	char semaphore_name[15]="sync_semaphore";
	char str[10];

	current_num_iss_hd =
	  CreateFileMapping((HANDLE)0xFFFFFFFF , NULL , PAGE_READWRITE , 0 , sizeof(DWORD) , "toppers_current_num_iss");
	
	toppers_current_num_iss = (DWORD *)MapViewOfFile(current_num_iss_hd, FILE_MAP_ALL_ACCESS , 0 , 0 , 0);
	toppers_current_num_iss_semaphore = CreateSemaphore(0,1,1,"current_num_iss_semaphore");

	changed_sync_cycles_hd =
	  CreateFileMapping((HANDLE)0xFFFFFFFF , NULL , PAGE_READWRITE , 0 , sizeof(DWORD) , "toppers_changed_sync_cycles");

	toppers_changed_sync_cycles = (DWORD *)MapViewOfFile(changed_sync_cycles_hd, FILE_MAP_ALL_ACCESS , 0 , 0 , 0);

	temp_changed_sync_cycles_hd =
	  CreateFileMapping((HANDLE)0xFFFFFFFF , NULL , PAGE_READWRITE , 0 , sizeof(DWORD) , "toppers_temp_changed_sync_cycles");

	toppers_temp_changed_sync_cycles =  (DWORD *)MapViewOfFile(temp_changed_sync_cycles_hd, FILE_MAP_ALL_ACCESS , 0 , 0 , 0);

	end_num_iss_hd=
	  	  CreateFileMapping((HANDLE)0xFFFFFFFF , NULL , PAGE_READWRITE , 0 , sizeof(DWORD) , "toppers_end_num_iss");
    toppers_end_num_iss = (DWORD *)MapViewOfFile(end_num_iss_hd, FILE_MAP_ALL_ACCESS , 0 , 0 , 0);
	for(i=0;i<toppers_num_iss;i++){
		sprintf(str,"%d",i);
		strcat(semaphore_name,str);
		toppers_sync_semaphore[i] = CreateSemaphore(0,0,1,semaphore_name);
	}

}

/*
 * \brief @\p̏s
 */
void toppers_init_sync(){
	toppers_sync_enable=FALSE;
	toppers_sync_cycles=DEFAULT_SYNC_CYCLES;
	toppers_next_sync_cycles=DEFAULT_SYNC_CYCLES;
}
/*
 * \brief @\p̏Is
 */
void toppers_end_sync(){
	int i;
	if(toppers_sync_enable){
		WaitForSingleObject(toppers_current_num_iss_semaphore,INFINITE);
		*toppers_end_num_iss +=1;
		/* SISSI */
		if(*toppers_end_num_iss == toppers_num_iss){
			ReleaseSemaphore(toppers_current_num_iss_semaphore,1,NULL);
			for(i=0;i<toppers_num_iss;i++){
				CloseHandle(toppers_sync_semaphore[i]);
			}
			CloseHandle(current_num_iss_hd);
			CloseHandle(changed_sync_cycles_hd);
			CloseHandle(temp_changed_sync_cycles_hd);
			CloseHandle(end_num_iss_hd);
			CloseHandle(toppers_current_num_iss_semaphore);
			
		}/* sISS */
		else{
			ReleaseSemaphore(toppers_current_num_iss_semaphore,1,NULL);
			for(i=0;i<toppers_num_iss;i++){
				ReleaseSemaphore(toppers_sync_semaphore[i],1,NULL);
			}
		}
	}

}
/*
 * \brief TCN̕ύXs
 * \param[in] changed_cycles ύXp̓TCN
 */
extern "C"
_cdecl void toppers_change_sync_cycles(DWORD changed_cycles){
	*toppers_temp_changed_sync_cycles = changed_cycles;
}
