/*
	toppers_skyeye_options.c
    Copyright (C) 2006-2009 by Embedded and Real-Time Systems Laboratory
              Graduate School of Information Science, Nagoya Univ., JAPAN
	
	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
 
*/
/* toppers_add at 2007-10-1
 * AT91ȊÕvZbTɂΉ鎞skyeye_config.archparse֐
 * ǉ(mem_bankQl)
 */
extern int toppers_devm_set_id (unsigned long id);
extern void toppers_devm_map_subid (unsigned long subid, unsigned int irq);
extern int toppers_set_affinity (unsigned long id);
extern void toppers_calc_clock_freq (void);

extern unsigned int toppers_int_out_reg;
extern unsigned int toppers_mutex_base;

extern char * toppers_gdb_port;
extern unsigned int toppers_prc_id_reg;
extern unsigned int toppers_prc_id;
extern unsigned int toppers_perf_time_base;
extern unsigned int toppers_cycle_counter;

static char toppers_gdb_port_prefix[] = "port:";

/*
 * toppers_add at 2007-10-1
 * \brief vZbTIDpIvV
 * \param[in] this_option IvV
 * \param[in] num_params  p[^
 * \param[in] params      p[^ivZbTIDj
 * \retval 0  IvV̐ݒ̐
 * \retval -1 IvV̐ݒ̎s
 */
int
toppers_do_devm_int_id_option (struct skyeye_option_t *this_option, int num_params, const char *params[])
{
	int i;
	char name[MAX_PARAM_NAME], value[MAX_PARAM_NAME];
	unsigned long id = 0;

	for (i = 0; i < num_params; i++) {
		if (params[0][0] == '0' && params[0][1] == 'x')
		  id = strtoul (params[0], NULL, 16);
		else
		  id = strtoul (params[0], NULL, 10);
	}

	if (id != 0) {
		if (toppers_devm_set_id (id) == 0){
			return -1;
		}
		/* vZbTIDłɐݒ肳Ă邩mF*/
		if (toppers_prc_id == -1) {
			toppers_prc_id = id;
		}
	}
	else {
		SKYEYE_ERR ("Error: COM Interrupt ID must be larger than 0\n");
	}
	return 0;
}
/*
 * toppers_add at 2007-10-1
 * \brief vZbTݏo͗pIvV
 * \param[in] this_option IvV
 * \param[in] num_params  p[^
 * \param[in] params      p[^ibase=vZbTݏo͗p̃AhXj
 * \retval 0  IvV̐ݒ̐
 * \retval -1 IvV̐ݒ̎s
 */
int
toppers_do_devm_int_out_option (struct skyeye_option_t *this_option, int num_params, const char *params[])
{
	int i;
	char name[MAX_PARAM_NAME], value[MAX_PARAM_NAME];

	for (i = 0; i < num_params; i++) {
		if (split_param (params[i], name, value) < 0) {
			SKYEYE_ERR ("Error: %s has wrong parameter \"%s\".\n",
						this_option->name, name);
			return -1;
		}
		if (!strncmp ("base", name, strlen (name))) {
			if (value[0] == '0' && value[1] == 'x')
			  toppers_int_out_reg = strtoul (value, NULL, 16);
			else
			  toppers_int_out_reg = strtoul (value, NULL, 10);
		}
		else {
			SKYEYE_ERR ("Error: %s has unknow parameter \"%s\".\n",
						this_option->name, name);
		}
	}
	return 0;
}
/*
 * toppers_add at 2007-10-1
 * \brief vZbTݓ͗pIvV
 * \param[in] this_option IvV
 * \param[in] num_params  p[^
 * \param[in] params      p[^isubid=foCX}l[W瑗
 *                                          Ă銄ݔԍ
 *                                  iIRQ=ݓ̓|[gj
 * \retval 0  IvV̐ݒ̐
 * \retval -1 IvV̐ݒ̎s
 */

int
toppers_do_devm_int_in_option (struct skyeye_option_t *this_option, int num_params, const char *params[])
{
	int i;
	unsigned long subid;
	unsigned int irq;
	char name[MAX_PARAM_NAME], value[MAX_PARAM_NAME];

	for (i = 0; i < num_params; i++) {
		if (split_param (params[i], name, value) < 0) {
			SKYEYE_ERR ("Error: %s has wrong parameter \"%s\".\n",
						this_option->name, name);
			return -1;
		}
		if (!strncmp ("subid", name, strlen (name))) {
			if (value[0] == '0' && value[1] == 'x')
			  subid = strtoul (value, NULL, 16);
			else
			  subid = strtoul (value, NULL, 10);
		}
		else if (!strncmp ("IRQ", name, strlen (name))) {
			if (value[0] == '0' && value[1] == 'x')
			  irq = strtoul (value, NULL, 16);
			else
			  irq = strtoul (value, NULL, 10);
		}
		else {
			SKYEYE_ERR ("Error: %s has unknow parameter \"%s\".\n",
						this_option->name, name);
		}
	}
	toppers_devm_map_subid(subid, irq);
	return 0;
}
/*
 * toppers_add at 2007-10-1
 * \brief ~[ebNXRg[pIvV
 * \param[in] this_option IvV
 * \param[in] num_params  p[^
 * \param[in] params      p[^ibase=~[ebNXANZXp
 *                                   AhXj
 * \retval 0  IvV̐ݒ̐
 * \retval -1 IvV̐ݒ̎s
 */

int
toppers_do_devm_mutex_cont_option (struct skyeye_option_t *this_option, int num_params, const char *params[])
{
	int i;
	char name[MAX_PARAM_NAME], value[MAX_PARAM_NAME];

	for (i = 0; i < num_params; i++) {
		if (split_param (params[i], name, value) < 0) {
			SKYEYE_ERR ("Error: %s has wrong parameter \"%s\".\n",
						this_option->name, name);
			return -1;
		}
		if (!strncmp ("base", name, strlen (name))) {
			if (value[0] == '0' && value[1] == 'x')
			  toppers_mutex_base = strtoul (value, NULL, 16);
			else
			  toppers_mutex_base = strtoul (value, NULL, 10);
		}
		else {
			SKYEYE_ERR ("Error: %s has unknow parameter \"%s\".\n",
						this_option->name, name);
		}
	}
	return 0;
}

/*
 * toppers_add at 2007-10-1
 * \brief ~[ebNXRg[pIvV
 * \param[in] this_option IvV
 * \param[in] num_params  p[^
 * \param[in] params      p[^iid=gp~[ebNXIDj
 * \retval 0  IvV̐ݒ̐
 * \retval -1 IvV̐ݒ̎s
 */

int
toppers_do_devm_mutex_obj_option (struct skyeye_option_t *this_option, int num_params, const char *params[])
{
	int i;
	int id;
	char name[MAX_PARAM_NAME], value[MAX_PARAM_NAME];

	for (i = 0; i < num_params; i++) {
		if (split_param (params[i], name, value) < 0) {
			SKYEYE_ERR ("Error: %s has wrong parameter \"%s\".\n",
						this_option->name, name);
			return -1;
		}
		if (!strncmp ("id", name, strlen (name))) {
			if (value[0] == '0' && value[1] == 'x')
			  id = strtoul (value, NULL, 16);
			else
			  id = strtoul (value, NULL, 10);
		}
		else {
			SKYEYE_ERR ("Error: %s has unknow parameter \"%s\".\n",
						this_option->name, name);
		}
	}
	toppers_create_mutex (id);
	return 0;
}
/*
 * toppers_add at 2007-10-1
 * \brief [gfobÕ|[gwIvV
 * \param[in] this_option IvV
 * \param[in] num_params  p[^
 * \param[in] params      p[^i|[gԍj
 * \retval 0  IvV̐ݒ̐
 * \retval -1 IvV̐ݒ̎s
 */
int
toppers_do_debug_tcp_option (struct skyeye_option_t *this_option, int num_params, const char *params[])
{
	int i;
	static char custom_port[32] = "port:";

	if (num_params > 1) {
		SKYEYE_ERR ("Error: %s must have one parameter.\n", this_option->name);
		return -1;
	}
	if (strlen (custom_port) + strlen (params[0]) + 1 > sizeof(custom_port)) {
		SKYEYE_ERR ("Error: %s got too long parameter.\n", this_option->name);
		return -1;
	}
	/* params[0]̍Ō̏I[('\0')܂ŃRs[ */
	memcpy (custom_port + strlen (custom_port), params[0], strlen (params[0]) + 1);
	toppers_gdb_port = custom_port;
	return 0;
}
/*
 * toppers_add at 2007-10-1
 * \brief vZbTID擾pIvV
 * \param[in] this_option IvV
 * \param[in] num_params  p[^
 * \param[in] params      p[^ibase=vZbTID擾p̃AhXj
 *                                  iid=vZbTIDj
 * \retval 0  IvV̐ݒ̐
 * \retval -1 IvV̐ݒ̎s
 */

int
toppers_do_prc_id_option (struct skyeye_option_t *this_option, int num_params, const char *params[])
{
	int i;
	char name[MAX_PARAM_NAME], value[MAX_PARAM_NAME];

	for (i = 0; i < num_params; i++) {
		if (split_param (params[i], name, value) < 0) {
			SKYEYE_ERR ("Error: %s has wrong parameter \"%s\".\n",
						this_option->name, name);
			return -1;
		}
		if (!strncmp ("base", name, strlen (name))) {
			if (value[0] == '0' && value[1] == 'x')
			  toppers_prc_id_reg = strtoul (value, NULL, 16);
			else
			  toppers_prc_id_reg = strtoul (value, NULL, 10);
		}
		else if (!strncmp ("id", name, strlen (name))) {
			if (value[0] == '0' && value[1] == 'x')
			  toppers_prc_id = strtoul (value, NULL, 16);
			else
			  toppers_prc_id = strtoul (value, NULL, 10);
		}
		else {
			SKYEYE_ERR ("Error: %s has unknow parameter \"%s\".\n",
						this_option->name, name);
		}
	}
	return 0;
}
/*
 * toppers_add at 2007-10-1
 * \brief \]iԎ擾jpIvV
 * \param[in] this_option IvV
 * \param[in] num_params  p[^
 * \param[in] params      p[^ibase=zXgPC̋NĂ̎
 *                                    擾邽߂̃AhXj
 * \retval 0  IvV̐ݒ̐
 * \retval -1 IvV̐ݒ̎s
 */

int
toppers_do_perf_time_option (struct skyeye_option_t *this_option, int num_params, const char *params[])
{
	int i;
	char name[MAX_PARAM_NAME], value[MAX_PARAM_NAME];

	for (i = 0; i < num_params; i++) {
		if (split_param (params[i], name, value) < 0) {
			SKYEYE_ERR ("Error: %s has wrong parameter \"%s\".\n",
						this_option->name, name);
			return -1;
		}
		if (!strncmp ("base", name, strlen (name))) {
			if (value[0] == '0' && value[1] == 'x')
			  toppers_perf_time_base = strtoul (value, NULL, 16);
			else
			  toppers_perf_time_base = strtoul (value, NULL, 10);
		}
		else {
			SKYEYE_ERR ("Error: %s has unknow parameter \"%s\".\n",
						this_option->name, name);
		}
	}
	if (toppers_perf_time_base != 0) {
		toppers_calc_clock_freq ();
	}
	return 0;
}
/*
 * toppers_add at 2007-10-1
 * \brief \]piAtBjeBݒjIvV
 * \param[in] this_option IvV
 * \param[in] num_params  p[^
 * \param[in] params      p[^iid=szXgIDj
 * \retval 0  IvV̐ݒ̐
 * \retval -1 IvV̐ݒ̎s
 */
int
toppers_do_prc_affinity_option (struct skyeye_option_t *this_option, int num_params, const char *params[])
{
	int i;
	long affinity_id = -1;
	char name[MAX_PARAM_NAME], value[MAX_PARAM_NAME];

	for (i = 0; i < num_params; i++) {
		if (split_param (params[i], name, value) < 0) {
			SKYEYE_ERR ("Error: %s has wrong parameter \"%s\".\n",
						this_option->name, name);
			return -1;
		}
		if (!strncmp ("id", name, strlen (name))) {
			if (value[0] == '0' && value[1] == 'x')
			  affinity_id = strtoul (value, NULL, 16);
			else
			  affinity_id = strtoul (value, NULL, 10);
		}
		else {
			SKYEYE_ERR ("Error: %s has unknow parameter \"%s\".\n",
						this_option->name, name);
		}
	}
	if (affinity_id >= 0) {
		return toppers_set_affinity (affinity_id);
	}
	return 0;
}
/*
 * toppers_add at 2007-10-1
 * \brief TCN擾pIvV
 * \param[in] this_option IvV
 * \param[in] num_params  p[^
 * \param[in] params      p[^ibase=SkyEye̋NĂ
 *                      V~[VTCN擾AhXj
 * \retval 0  IvV̐ݒ̐
 * \retval -1 IvV̐ݒ̎s
 */
int
toppers_do_cycle_counter_option (struct skyeye_option_t *this_option, int num_params, const char *params[])
{
	int i;
	char name[MAX_PARAM_NAME], value[MAX_PARAM_NAME];

	for (i = 0; i < num_params; i++) {
		if (split_param (params[i], name, value) < 0) {
			SKYEYE_ERR ("Error: %s has wrong parameter \"%s\".\n",
						this_option->name, name);
			return -1;
		}
		if (!strncmp ("base", name, strlen (name))) {
			if (value[0] == '0' && value[1] == 'x')
			  toppers_cycle_counter = strtoul (value, NULL, 16);
			else
			  toppers_cycle_counter = strtoul (value, NULL, 10);
		}
		else {
			SKYEYE_ERR ("Error: %s has unknow parameter \"%s\".\n",
						this_option->name, name);
		}
	}
	return 0;
}

/*
 * toppers_add at 2008-03-21 for synchronous
 */

extern int toppers_num_iss;                    /* ISSێ */
extern int toppers_sync_enable;                /* @\̗L/𔻒f邽߂̃tO */
extern unsigned long toppers_next_sync_cycles; /* n_̃TCNiݐρj */
extern unsigned long toppers_sync_cycles;      /* TCNԊu */
extern ARMword toppers_sync_cycle_base;        /* TCNύXp̃x[XAhX */
extern void toppers_make_shared_object(void);  /* @\pLIuWFNg쐬 */
extern void toppres_change_sync_cycles(int changed_cycles); /* TCN̕ύXs */

/*
 * toppers_add at 2008-03-21
 * \brief pIvV
 * \param[in] this_option IvV
 * \param[in] num_params  p[^
 * \param[in] params      p[^inum=SkyEye̐C
 *                             cycles=TCNC
 *                             base=TCNύXp̃AhXj
 * \retval 0  IvV̐ݒ̐
 * \retval -1 IvV̐ݒ̎s
 */

int
toppers_do_sync_option (struct skyeye_option_t *this_option, int num_params, const char *params[])
{
	int i;
	char name[MAX_PARAM_NAME], value[MAX_PARAM_NAME];
	unsigned long num = 0;
	unsigned long cycles;
	for (i = 0; i < num_params; i++) {
		if (split_param (params[i], name, value) < 0) {
			SKYEYE_ERR ("Error: %s has wrong parameter \"%s\".\n",
						this_option->name, name);
			return -1;
		}
		/* ISS̎擾 */
		if(!strncmp ("num", name, strlen (name))) {
			num=strtoul (value, NULL, 10);
			if (num != 0) {
				toppers_num_iss = num;
				toppers_sync_enable = TRUE;
				toppers_make_shared_object();
			}
			else {
				SKYEYE_ERR ("Error: num_sim must be larger than 0\n");
			}
		} /* TCN̎擾 */
		else if(!strncmp ("cycles",name,strlen(name))) {
			cycles = strtoul (value, NULL, 10);
			if (cycles > 0) {
				toppers_change_sync_cycles(cycles);
				toppers_sync_cycles = cycles;
				toppers_next_sync_cycles = cycles;
			}
			else{
				SKYEYE_ERR ("Error: sync_cycles must be larger than 0\n");
			}

		} /* TCNύXpx[XAhX̎擾 */
		else if(!strncmp ("base", name, strlen (name))) {
			if (value[0] == '0' && value[1] == 'x'){
				toppers_sync_cycle_base = strtoul (value, NULL, 16);
			}
			else{
				toppers_sync_cycle_base = strtoul (value, NULL, 10);
			}
		}
		else {
			SKYEYE_ERR ("Error: %s has unknow parameter \"%s\".\n",
						this_option->name, name);
		}
	}
	return 0;
}
